

#include "stdafx.h"

#include <stdlib.h>
#include <stdio.h>



#include "os.h"
#include "wimp.h"


#include "etc.h"
#include "err.h"
#include "transform.h"
#include "fsx.h"
#include "bf.h"
#include "flex.h"
#include "alloc.h"
#include "xmath.h"
#include "osglue.h"
#include "osgraphics.h"
#include "osunits.h"
#include "oserr.h"
#include "deb.h"
#include "colour.h"
#include "sprx.h"
#include "bitrev.h"
#include "xprocess.h"

#include "imlib.h"
#include "bmphdr.h"
#include "bmpim.h"
#include "imrender.h"
#include "ossprite.h"



typedef struct bcmphdrstr
{
 BITMAPINFOHEADER bmi;
 RGBQUAD          pal[256];


} bcmphdrstr;








os_error * imnewframebase(framebasestr ** framebase)
{
 os_error * err;

 err=salloc((flex_ptr)framebase,sizeof(framebasestr));

 return(err);
}


os_error * imscrapframebase(framebasestr ** framebase)
{
 os_error * err;
 int        i;
 int        j;

 err=NULL;

 if(*framebase)
 {
  for(i=0;i<(*framebase)->framen;i++)
  {
   for(j=0;j<(*framebase)->frame[i].planes;j++)
   {
    err=flex_free((flex_ptr)&(*framebase)->frame[i].im[j].data);
    if(err) break;

				if((*framebase)->frame[i].im[j].iccdata)	free((*framebase)->frame[i].im[j].iccdata);
   }
   if(err) break;
  }

  if(!err)
  {
   sfree((flex_ptr)framebase);
  }
 }

 return(err);
}



os_error * imaddframe(framebasestr ** framebase,framestr ** frames)
{
 os_error * err;

 err=NULL;

 (*framebase)->framen++;
 *frames=&(*framebase)->frame[0];

 return(err);
}



os_error * imnew(int xpix,int ypix,int bpp,imagestr * im)
{
 os_error * err;

 im->bpp=bpp;
 im->xpix=xpix;
 im->ypix=ypix;
 im->wwidth=((xpix*bpp+31)&~(31))/8;


 err=flex_alloc((flex_ptr)&im->data,ypix*im->wwidth);

 return(err);
}



os_error * imfind1w(imagestr * image,int y,int ** idata)
{
 *idata=(int*)(((char*)image->data)+y*image->wwidth);
 return(NULL);
}


os_error * imfind1r(imagestr * image,int y,int ** idata)
{
 *idata=(int*)(((char*)image->data)+y*image->wwidth);
 return(NULL);
}



os_error * imzero(imagestr * image)
{
 memset(image->data,0,image->ypix*image->wwidth);
 return(NULL);
}




os_error * imnormalise(imagestr * im,int ** idata,int * buffer)
{

 if(im->usergbmask)
 {
  int          r;
  int          g;
  int          b;
  int          rshift=im->rshift;
  int          gshift=im->gshift;
  int          bshift=im->bshift;
  int          rmask=im->rmask;
  int          gmask=im->gmask;
  int          bmask=im->bmask;
  unsigned int c1;
  unsigned int c2;
  int        * prw;
  int        * pww;
  int        * pwrowltw;

  prw=*idata;
  *idata=buffer;
  pww=buffer;
  pwrowltw=pww+(im->wwidth/sizeof(int));

  if(im->bpp==15 || im->bpp==16)
  {
   while(pww<pwrowltw)
   {
    c1=(unsigned int)*prw++;
    r=(c1 & rmask)>>rshift;
    g=(c1 & gmask)>>gshift;
    b=(c1 & bmask)>>bshift;
    c2=b|(g<<5)|(r<<10);

    c1=c1>>16;
    r=(c1 & rmask)>>rshift;
    g=(c1 & gmask)>>gshift;
    b=(c1 & bmask)>>bshift;
    c2|=(b<<16)|(g<<(5+16))|(r<<(10+16));

    *pww++=c2;
   }
  }
  else
  if(im->bpp==32)
  {
   while(pww<pwrowltw)
   {
    c1=(unsigned int)*prw++;
    r=(c1 & rmask)>>rshift;
    g=(c1 & gmask)>>gshift;
    b=(c1 & bmask)>>bshift;
  
    *pww++=b|(g<<8)|(r<<16);
   }
  }
 }

 return(NULL);
}


int impixelxy(int x,int y,imagestr * im)
{
 char * p;
 int    shift;

 p=(((char*)im->data)+y*im->wwidth);

 shift=x*im->bpp;

 p+=shift/8;
 shift=(shift&0x7);

 switch(im->bpp)
 {
  case  1:
          return(((*p)>>(7-shift))&0x1);
  case  2:
          return(((*p)>>(6-shift))&0x3);
  case  4:
          return(((*p)>>(4-shift))&0xF);
  case  8:
          return(*p);
  case 16:
          return((*p)+((*(p+1))<<8));
  case 24:
          return((*p)+((*(p+1))<<8)+((*(p+1))<<16));
  case 32:
          return(*((int*)p));
 }
 return(0);
}



#ifdef NEVER

os_error * imrenderparallel(framestr * frame,hdcstr * hdcptr,POINT * pts)
{
 bcmphdrstr  bmi;


// cprintf("impaintim topdown %d w %d h %d",im->topdown,w,h);

 memset(&bmi,0,sizeof(bmi));

 if(im->bpp<=8)
 {
  XMEMCPYX(&bmi.pal,&im->ipal,sizeof(int)*(1<<im->bpp));
 }

 bmi.bmi.biWidth=im->xpix;
// bmi.bmi.biHeight=im->ypix;
// if(!im->topdown)
// {
//  h=-h;
//  oy-=h;
// }
 bmi.bmi.biHeight=im->topdown?im->ypix:-im->ypix;
 if(h<0) {h=-h;bmi.bmi.biHeight=-bmi.bmi.biHeight;oy-=h;}

 bmi.bmi.biXPelsPerMeter=0;
 bmi.bmi.biYPelsPerMeter=0;
 bmi.bmi.biBitCount=(unsigned short)im->bpp;
 bmi.bmi.biPlanes=1;
 bmi.bmi.biCompression=im->usergbmask?BI_BITFIELDS:BI_RGB;
 bmi.bmi.biSize=sizeof(BITMAPINFOHEADER);
 bmi.bmi.biSizeImage=0;
 bmi.bmi.biClrImportant=0;
 bmi.bmi.biClrUsed=0;

 if(im->usergbmask)
 {
  *(int*)&bmi.pal[0]=im->rmask;
  *(int*)&bmi.pal[1]=im->gmask;
  *(int*)&bmi.pal[2]=im->bmask;
 }

 hdcmem=CreateCompatibleDC(hdcptr->hdc);

 SelectObject(hdcmem,hbm);


 SetStretchBltMode(currenthdcptr->hdc,COLORONCOLOR);

 code=PlgBlt(hdcptr->hdc,          // handle to destination DC
             pts, // destination vertices
             hdcmem,           // handle to source DC
             0,            // x-coord of source upper-left corner
             0,            // y-coord of source upper-left corner
             im->xpix,           // width of source rectangle
             im->ypix,          // height of source rectangle
             NULL,      // handle to bitmask
             0,            // x-coord of bitmask upper-left corner
             0             // y-coord of bitmask upper-left corner
            );

 return(NULL);
}



#endif


os_error * impaintim(imagestr * im,int ox,int oy,int w,int h)
{
 bcmphdrstr  bmi;


// cprintf("impaintim topdown %d w %d h %d",im->topdown,w,h);

 memset(&bmi,0,sizeof(bmi));

 if(im->bpp<=8)
 {
  XMEMCPYX(&bmi.pal,&im->ipal,sizeof(int)*(1<<im->bpp));
 }

 bmi.bmi.biWidth=im->xpix;
// bmi.bmi.biHeight=im->ypix;
// if(!im->topdown)
// {
//  h=-h;
//  oy-=h;
// }
 bmi.bmi.biHeight=im->topdown?im->ypix:-im->ypix;
 if(h<0) {h=-h;bmi.bmi.biHeight=-bmi.bmi.biHeight;oy-=h;}

 bmi.bmi.biXPelsPerMeter=0;
 bmi.bmi.biYPelsPerMeter=0;
 bmi.bmi.biBitCount=(unsigned short)im->bpp;
 bmi.bmi.biPlanes=1;
 bmi.bmi.biCompression=im->usergbmask?BI_BITFIELDS:BI_RGB;
 bmi.bmi.biSize=sizeof(BITMAPINFOHEADER);
 bmi.bmi.biSizeImage=0;
 bmi.bmi.biClrImportant=0;
 bmi.bmi.biClrUsed=0;

 if(im->usergbmask)
 {
  *(int*)&bmi.pal[0]=im->rmask;
  *(int*)&bmi.pal[1]=im->gmask;
  *(int*)&bmi.pal[2]=im->bmask;
 }


 SetStretchBltMode(currenthdcptr->hdc,COLORONCOLOR);

 StretchDIBits(currenthdcptr->hdc,
               ox,           // x-coordinate of upper-left corner of dest. rectangle
               oy,           // y-coordinate of upper-left corner of dest. rectangle
               w,            // width of destination rectangle
               h,            // height of destination rectangle
               0,              // x-coordinate of upper-left corner of source rectangle
               0,              // y-coordinate of upper-left corner of source rectangle
               im->xpix,            // width of source rectangle
               im->ypix,            // height of source rectangle
               im->data, // address of bitmap bits
               (BITMAPINFO*)&bmi,           // address of bitmap data
               DIB_RGB_COLORS, // usage flags
               SRCCOPY         // raster operation code
              );


 return(NULL);
}




os_error * impaint(framestr * frame,int ox,int oy,int w,int h)
{
 return(impaintim(&frame->im[0],ox,oy,w,h));
}



os_error * impaintos(framestr * frame,int ox,int oy,int w,int h)
{
 return(impaintim(&frame->im[0],GRXPIX(ox),GRYPIX(oy),xos2pix(w),yos2pix(h)));
}






// passed rectangle to render image to

os_error * impaintbox(framestr * frame,coordstr * cx,processstr * pr)
{
 os_error * err;
 POINT      pts[4];
 int        i;
 int        regular;


 for(i=0;i<4;i++)
 {
  pts[i].x=GRDXPIX(cx[i].x);
  pts[i].y=GRDYPIX(cx[i].y);
 }

// LPtoDP(currenthdcptr->hdc,pts,4);

// graphicsostext2(currenthdcptr);

 regular=(pts[0].y==pts[1].y && pts[2].y==pts[3].y &&
          pts[0].x==pts[3].x && pts[1].x==pts[2].x);

 if(pr && pr->mode!=PROCESSNONE) regular=0;
 if(frame->im[IM].ipal.palclass==CL_CMYK) regular=0;

 // in aid of taking out scaled images with -ve height for LJ printers
// if(pr && pr->isprinter)
// {
//  if(((pts[3].y-pts[0].y)>0 && !frame->im[IM].topdown) ||
//     ((pts[3].y-pts[0].y)<0 && frame->im[IM].topdown)) regular=0;
// }

 if(regular)
 {
  err=impaint(frame,pts[0].x,pts[0].y,pts[1].x-pts[0].x,pts[3].y-pts[0].y);   // x,y top left of sprite
 }
 else
 {
  err=imrenderbox(frame,currenthdcptr,pts,pr);

 }

// graphicsriscos2(currenthdcptr);
  
 return(NULL);
}




os_error * imnewscreen(int xpix,int ypix,int bpp,imagestr * im,imagescreenstr * handle)
{
 os_error   * err;
 bcmphdrstr   bmi;
 HBITMAP      hbm;
 HDC          hdcmem;
 int        * dbits;
 hdcstr     * hdcptr;
 int          scx=0;
 int          scy=0;

 im->bpp=bpp;
 im->xpix=xpix;
 im->ypix=ypix;
 im->wwidth=((xpix*bpp+31)&~(31))/8;


 hdcmem=CreateCompatibleDC(NULL);

 memset(&bmi,0,sizeof(bmi));
   
 if(bpp<=8)
 {
  XMEMCPYX(&bmi.pal[0],&im->ipal,sizeof(int)*(1<<bpp));
 }

 bmi.bmi.biWidth=xpix;
 bmi.bmi.biHeight=-ypix;
 bmi.bmi.biXPelsPerMeter=scale(im->xdpi,10000,254);
 bmi.bmi.biYPelsPerMeter=scale(im->ydpi,10000,254);
 bmi.bmi.biBitCount=(unsigned short)bpp;
 bmi.bmi.biPlanes=1;
 bmi.bmi.biCompression=BI_RGB;
 bmi.bmi.biSize=sizeof(BITMAPINFOHEADER);
 bmi.bmi.biSizeImage=0;
 bmi.bmi.biClrImportant=0;
 bmi.bmi.biClrUsed=0;

 err=XCreateDIBSection(hdcmem,(BITMAPINFO*)&bmi,DIB_RGB_COLORS,(void**)&dbits,NULL,0,&hbm);
 if(!err)
 {
  im->data=dbits;
  SelectObject(hdcmem,hbm);

//  memset(dbits,0xFF,ypix*im->wwidth);

//  MoveToEx(hdcmem,0,0,NULL);
//  LineTo(hdcmem,100,100);

  handle->hdc=(oshdc)hdcmem;
  handle->hbm=(ishbm)hbm;
  handle->im=im;

  graphicsnewhdc(&hdcptr);
  handle->hdcptr=(oshdc)hdcptr;
  hdcptr->hdc=hdcmem;

  graphicsinit2(-scx,scy,hdcptr);

//  graphicsscaleboth2(OSXRES,OSYRES,im->xdpi,im->ydpi,hdcptr);
 }


 return(err);
}



//extern void       vdumodevars1(HDC hdc,vdustr * vdu);


os_error * imsetscreen(imagescreenstr * handle,int set)
{
 static hdcstr * hdcptr;

 if(set)
 {
  hdcptr=currenthdcptr;
  graphicssetcurrent((hdcstr*)handle->hdcptr);
 }
 else
 {
  graphicssetcurrent(hdcptr);
 }

/*
 if(currenthdcptr)
 {
  vdumodevars1(currenthdcptr->hdc,&cvdu);
 }

 cprintf("setvdu xdpi %d ydpi %d bpp %d",cvdu.xdpi,cvdu.ydpi,cvdu.bpp);
*/
 return(NULL);
}




os_error * imdeletescreen(imagescreenstr * handle)
{

 graphicsclearcurrent((hdcstr*)handle->hdcptr);
 graphicsfinit2((hdcstr*)handle->hdcptr);
 DeleteDC((HDC)handle->hdc);
 graphicsdeletehdc((hdcstr*)handle->hdcptr);
  
 DeleteObject((HBITMAP)handle->hbm);

 return(NULL);
}



/**************************************************************************/


void imgetsppal(imagestr * im,newsprite_header * sph)
{
 int spbpp;
 int i;

 getspriteinfo((newsprite_header*)sph,NULL,NULL,&spbpp);
 spgetpal(sph,&im->ipal.ncolours,im->ipal.word);
 genpal256(im->ipal.word,ln2bpptab[spbpp],&im->ipal.ncolours);
 for(i=0;i<im->ipal.ncolours;i++)
 {
  im->ipal.word[i]=QUADFROMPAL(im->ipal.word[i]);
 }
 im->ipal.palclass=CL_RGB;
}
  


os_error * imgetspritebits(imagestr * im,newsprite_header * sph,int mask)
{
 int * bits;
 int   bitwidth;
 int   sbytewidth;
 int   xpix;
 int   ypix;
 int   spbpp;
 char * p;
 char * q;
 char * lt;
 int  * prw;
 int  * pww;
 int  * ltw;
 int    c;

// cprintf("imgetsp %x",sph);

 getspriteinfo((newsprite_header*)sph,NULL,NULL,&spbpp);


 sbytewidth=4*(sph->width+1);
 bitwidth=32*(sph->width+1)-sph->lbit-(31-sph->rbit);

 sph->lbit=0;

 xpix=bitwidth/spbpp;
 ypix=sph->height+1;

 if(mask)
 {
  bits=(int*)(((char*)sph)+sph->mask);
  if(((newsprite_header*)sph)->selector.type.type)
  {
   sbytewidth=((xpix+31) & ~0x1F)/8;
   spbpp=1;
  }
 }
 else
 {
  bits=(int*)(((char*)sph)+sph->image);
 }



 cprintf("xpix %d ypix %d bits %x",xpix,ypix,bits);
 cprintf("im xpix %d ypix %d",im->xpix,im->ypix);
 cprintf("im bpp %d spbpp %d",im->bpp,spbpp);

 if(im->bpp==spbpp && !mask)
 {
  switch(im->bpp)
  {
   case 1:
          p=(char*)bits;
          q=(char*)im->data;
          lt=q+ypix*sbytewidth;
          while(q<lt)
          {
           *p++=bitrev[*q++];
          }
          break;

  // case 2:                        never
  //        break;

   case 4:
          p=(char*)bits;
          q=(char*)im->data;
          lt=q+ypix*sbytewidth;
          while(q<lt)
          {
           *p++=nybrev[*q++];
          }
          break;


   case 8:
          XMEMCPYX(bits,im->data,ypix*sbytewidth);
          break;

  case 16:
          prw=im->data;
          pww=bits;
          ltw=(int*)(((char*)pww)+ypix*sbytewidth);
          while(pww<ltw)
          {
           c=*prw++;
           *pww++=((c & 0x1F)<<10)|((c & 0x3E0))|((c & 0x7C00)>>10)|
                 ((c & 0x1F0000)<<10)|((c & 0x3E00000))|((c & 0x7C000000)>>10);
          }
          break;

  case 24:
          pww=bits;
          p=(char*)im->data;
          xpix*=3;
          while(ypix--)
          {
           ltw=(int*)(((char*)pww)+sbytewidth);
           while(pww<ltw)
           {
            c=((*p++)<<16);
            c|=((*p++)<<8);
            c|=(*p++);
            *pww++=c;
           }
           p+=((xpix+3)&~0x3)-xpix;
          }
          break;

  case 32:
          prw=im->data;
          pww=bits;
          ltw=(int*)(((char*)pww)+ypix*sbytewidth);
          while(pww<ltw)
          {
           c=*prw++;
           *pww++=((c>>16)&0xFF)|(c & 0xFF00)|((c<<16) & 0xFF0000);
          }
          break;
  }
 }
 else
 {
  int    ibpp=im->bpp;
  int    iword=0;
  int    imask;
  int    ishift;
  int    ishift2;
  int    sword;
  int    sshift;
  int    smask;
  int  * irow=im->data;
  int  * srow=bits;
  int    r=0;
  int    g=0;
  int    b=0;
  int    x;
  int    y;
  char * prb;
  

  if(ibpp==1) imask=1;
  else
  if(ibpp==2) imask=3;
  else
  if(ibpp==4) imask=15;
  else
  if(ibpp==8) imask=255;
  else        imask=0xFFFF;


  if(spbpp==1) smask=1;
  else
  if(spbpp==2) smask=3;
  else
  if(spbpp==4) smask=15;
  else
  if(spbpp==8) smask=255;
  else         smask=0xFFFF;



  for(y=0;y<ypix;y++)
  {
   ishift=32;
   ishift2=0;
   sshift=0;
   sword=0;

   prw=irow;
   pww=srow;
   prb=(char*)prw;

   for(x=0;x<xpix;x++)
   {
    switch(ibpp)
    {
     case 1:
     case 2:
     case 4:
     case 8:
            if(ishift>=32)
            {
             iword=*prw++;
             ishift=0;
             ishift2=8-ibpp;
            }

            
            b=(iword>>(ishift+ishift2)) & imask;
            ishift2-=ibpp;
            if(ishift2<0)
            {
             ishift2=8-ibpp;
             ishift+=8;
            }

            r=(im->ipal.word[b]>>16) & 0xFF;
            g=(im->ipal.word[b]>>8) & 0xFF;
            b=(im->ipal.word[b]) & 0xFF;
            break;

     case 16:
            if(ishift>=32)
            {
             iword=*prw++;
             ishift=0;
            }
            b=(iword>>ishift) & imask;
            ishift+=ibpp;
            r=(b & im->rmask)>>im->rshift;
            g=(b & im->gmask)>>im->gshift;
            b=(b & im->bmask)>>im->bshift;
            break;

     case 24:
            b=*prb++;
            g=*prb++;
            r=*prb++;
            break;

     case 32:
            iword=*prw++;
            r=(iword & im->rmask)>>im->rshift;
            g=(iword & im->gmask)>>im->gshift;
            b=(iword & im->bmask)>>im->bshift;
            break;
    }


    if(r>0 && b>0 && g>0) b=smask;
    else                  b=0;

    switch(spbpp)
    {

     case 1:
     case 2:
     case 4:
     case 8:
            sword=sword | (b<<sshift);
            sshift+=spbpp;
            if(sshift>=32)
            {
             *pww++=sword;
             sword=0;
             sshift=0;
            }
            break;

     case 16:
     case 32:
     case 24:
            break;


    }
   }


   if(sshift)
   {
    switch(spbpp)
    {
     case 1:
     case 2:
     case 4:
     case 8:
            *pww++=sword;
            break;

     case 16:
     case 32:
     case 24:
            break;


    }
   }

   srow=(int*)(((char*)srow)+sbytewidth);
   irow=(int*)(((char*)irow)+im->wwidth);
  }
 }

 return(NULL);
}




/**************************************************************************/



#define STBASE 0
#define STABS  1
#define STRUN  2




static void setbitmask(int bpp,int rmask,int * rshiftp)
{
 int i;
 int rshift;
 int c1;


 rshift=-1;
 c1=0;

 for(i=0;i<32;i++)
 {
  if(rmask & (1<<i))
  {
   c1=i;
   if(rshift<0) rshift=i;
  }
 }

 if(rshift<0) rshift=0;


 if(bpp==16)
 {
  if((c1-rshift)>=5) rshift=c1-4;
 }
 else
 if(bpp==32)
 {
  if((c1-rshift)>=8) rshift=c1-7;
 }

 *rshiftp=rshift;
}




os_error * loadbmp(char * name,framebasestr ** framebase)
{
 os_error  * err;
 buffer      bf;
 bmpstr      bmp;
 int         pal[256];
 int         bpp;
 int         xpix;
 int         ypix;
 int         colours;
 int         r;
 int         g;
 int         b;
 int         i;
 int         x;
 int         y;
 int       * idata;
 imagestr  * loadimage;
 int         wwidth;
 int         offset;
 int         c=0;    // compiler
 int         count;
 char      * p;
 int         state;
 int         sshift;
 int         dshift;
 int         pad;
 int         c1;
 int         c2=0;
 int         topdown;
 int         rmask;
 int         gmask;
 int         bmask;
 int         rshift;
 int         gshift;
 int         bshift;
 framestr  * frames=NULL; // compiler
 int         xdpi=0; // compiler
 int         ydpi=0;

 bpp=xpix=ypix=colours=0;    /* compiler */
 topdown=0;
 rshift=gshift=bshift=0;
 rmask=gmask=bmask=0;


 err=bf_open(name,'r',DEFBUFFSIZE,&bf);
 if(!err)
 {
           err=bf_getc(&bf,&c1);  /* B */
  if(!err) err=bf_getc(&bf,&c2);  /* M */

  if(c1!='B' || c2!='M') err=generror(0,"This is not a BMP file");

  if(!err) err=bf_read(&bf,&bmp.hdr,sizeof(bmphdrstr));
  if(!err) err=bf_read(&bf,&bmp.info,bmp.hdr.cbfix-4);

  if(!err)
  {
   if(bmp.hdr.cbfix==C_OS2)
   {
    bpp=bmp.info.os2.bitcount;
    xpix=bmp.info.os2.cx;
    ypix=bmp.info.os2.cy;
    xdpi=0;
    ydpi=0;

    if(bpp>8) colours=0;
    else      colours=(1<<bpp);

    for(i=0;i<colours;i++)
    {
     bf_getc(&bf,&b);
     bf_getc(&bf,&g);
     bf_getc(&bf,&r);
     pal[i]=(r<<16)|(g<<8)|(b<<0);
    }
   }
   else
   {
    bpp=bmp.info.windows.bitcount;
    xpix=bmp.info.windows.cx;
    ypix=bmp.info.windows.cy;
    xdpi=scale(bmp.info.windows.xdpm,254,10000);
    ydpi=scale(bmp.info.windows.ydpm,254,10000);
    if(ypix<0)
    {
     ypix=-ypix;
     topdown=1;
    }

    colours=bmp.info.windows.ncolourused;
    if(bpp<=8)
    {
     if(colours==0) colours=(1<<bpp);

     for(i=0;i<colours;i++)
     {
      bf_getc(&bf,&b);
      bf_getc(&bf,&g);
      bf_getc(&bf,&r);
      pal[i]=(b<<0)|(g<<8)|(r<<16);
      bf_getc(&bf,&b);
     }
    }
    else
    {
     if(bmp.info.windows.compression==BI_BITFIELDS)
     {
      if(bmp.hdr.cbfix==C_WIN4 || bmp.hdr.cbfix==C_WIN5)
      {
       rmask=bmp.info.windows4.bV4RedMask;
       gmask=bmp.info.windows4.bV4GreenMask;
       bmask=bmp.info.windows4.bV4BlueMask;
      }
      else
      {
       bf_geti(&bf,&rmask);
       bf_geti(&bf,&gmask);
       bf_geti(&bf,&bmask);
      }

      setbitmask(bpp,rmask,&rshift);
      setbitmask(bpp,gmask,&gshift);
      setbitmask(bpp,bmask,&bshift);
     }
     else
     {
      if(bpp==16)
      {
       rshift=10;
       rmask=0x7C00;
       gshift=5;
       gmask=0x3E0;
       bshift=0;
       bmask=0x1F;
      }
      else
      if(bpp==32)
      {
       rshift=24;
       rmask=0xFF0000;
       gshift=16;
       gmask=0xFF00;
       bshift=0;
       bmask=0xFF;
      }
     }
    }
   }
  }

/* dprintf(0,"xp=%d yp=%d xr=%d yr=%d col=%d",xpix,ypix,bmpxres,bmpyres,colours); */

  if(!err)
  {
   imaddframe(framebase,&frames);
   strcpy(frames->name,"BMP");
   frames->planes=1;
   frames->im[0].data=NULL;

   err=imnew(xpix,ypix,bpp,&frames->im[0]);
  }

  if(!err)
  {
   loadimage=&frames->im[IM];

   frames->im[IM].xdpi=xdpi;
   frames->im[IM].ydpi=ydpi;
   frames->im[IM].topdown=1;

   frames->im[IM].ipal.ncolours=colours;
   frames->im[IM].ipal.palclass=CL_RGB;
   for(i=0;i<colours;i++)
   {
    frames->im[IM].ipal.word[i]=pal[i];
   }

   bf_tell(&bf,&offset);
   for(i=offset;i<bmp.hdr.offbits;i++) bf_getc(&bf,&b); /* skip */

   wwidth=((bpp*xpix+31) & ~0x1F)>>3;

   if(bmp.hdr.cbfix==C_OS2 || bmp.info.windows.compression==BI_RGB)
   {
   /* dprintf(1,"OS2/RGB"); */

    for(y=0;y<ypix;y++)
    {
     err=imfind1w(loadimage,topdown?y:(ypix-y-1),&idata);
     if(err) break;
     err=bf_read(&bf,idata,wwidth);
     if(err) break;

     if(bpp==32)
     {
      for(x=0;x<xpix;x++)
      {
       c1=*idata;

       r=(c1 & rmask)>>rshift;
       g=(c1 & gmask)>>gshift;
       b=(c1 & bmask)>>bshift;

       *idata++=b|(g<<8)|(r<<16);
      }
     }
     else
     if(bpp==16)
     {
      for(x=0;x<xpix;x+=2)
      {
       c1=*idata;
       r=(c1 & rmask)>>rshift;
       g=(c1 & gmask)>>gshift;
       b=(c1 & bmask)>>bshift;
       c2=b|(g<<5)|(r<<10);

       c1=c1>>16;
       r=(c1 & rmask)>>rshift;
       g=(c1 & gmask)>>gshift;
       b=(c1 & bmask)>>bshift;
       c2|=(b<<16)|(g<<(5+16))|(r<<(10+16));

       *idata++=c2;
      }
     }
     else
     if(bpp==24)
     {
/*
      p=(char*)idata;
      for(x=0;x<xpix;x++)
      {
       b=*p;
       *p=*(p+2);
       *(p+2)=(char)b;
       p+=3;
      }
*/
     }
     else
     {
      // imrevline(loadimage,topdown?y:(ypix-y-1));
     }
    }
   }
   else
   {
    if(bmp.info.windows.compression==BI_RLE8)
    {
   /*  dprintf(1,"RLE8"); */

     imzero(loadimage);
     count=0;
     state=STBASE;
     pad=0;

     for(y=(ypix-1);y>=0;y--)
     {
      err=imfind1w(loadimage,y,&idata);
      if(err) break;
      p=(char*)idata;


/* !!! worry get out with eol or x>=xpix                */
/* !!! can get eol code just after x>=xpix              */
/* Don't assume x inc's once for each loop - it doesn't */

     /* for(x=0;x<wwidth;x++) */
      x=0;
      while(1)
      { 
       if(count--)  
       {
        if(state==STABS) 
        {
         bf_getc(&bf,&c);
        }

        if(x<xpix)
        {
         *p++=(char)c;
        }
        x++;
       }
       else
       {
        if(state==STABS && pad) 
        {
         state=STBASE;
         bf_getc(&bf,&count);
        }

        bf_getc(&bf,&count);
        if(count==0)
        {
         bf_getc(&bf,&count);
         if(count==0) {break;}         /* eol */
         else
         if(count==1) {y=-1;break;}    /* eoimage */
         else
         if(count==2)                  /* skip x,y */
         {
          count=0;
          bf_getc(&bf,&c);
          x+=c;
          bf_getc(&bf,&c);

          if(c)
          {
//           imrevline(loadimage,y);
           y-=c;
           err=imfind1w(loadimage,y,&idata);
           if(err) break;
          }

          p=(char*)idata+x;
         }
         else                           /* goto absolute mode */
         {
          pad=(count & 0x1);
          state=STABS;
         }
        }
        else
        {
         state=STRUN;
         bf_getc(&bf,&c);
        }
       }
      }

//      imrevline(loadimage,y);
     }
    }
    else
    if(bmp.info.windows.compression==BI_RLE4)
    {

   /*  dprintf(1,"RLE4"); */

     imzero(loadimage);
     count=0;
     state=STBASE;
     sshift=0;
     pad=0;

     for(y=(ypix-1);y>=0;y--)
     {
      err=imfind1w(loadimage,y,&idata);
      if(err) break;
      p=(char*)idata;
      dshift=0;

/* !!! worry get out with eol or x>=xpix                */
/* !!! can get eol code just after x>=xpix              */
/* Don't assume x inc's once for each loop - it doesn't */

      x=0;
      while(1)
      {
       if(count--)
       {
        if(state==STABS) 
        {
         if(sshift) 
         {
          bf_getc(&bf,&c);
          if(c<0) break;
         }
        }

        if(x<xpix)
        {
         *p|=((c>>sshift) & 0x7)<<(4-dshift);
         if(dshift) p++;
        }
        x++;

        sshift^=4;
        dshift^=4;
       }
       else
       {
        if(state==STABS && pad) 
        {
         state=STBASE;
         bf_getc(&bf,&count);
        }

        bf_getc(&bf,&count);
        if(count==0)
        {
         bf_getc(&bf,&count);

         if(count==0)
         {
          break;                          /* eol */
         }
         else
         if(count==1) {y=-1;break;}       /* eoimage */
         else
         if(count==2)                     /* skip x,y */
         {
          count=0;
          bf_getc(&bf,&c);
          x+=c;
          bf_getc(&bf,&c);

          if(c)
          {
           y-=c;
           err=imfind1w(loadimage,y,&idata);
           if(err) break;
          }

          if(x & 1) dshift=4;
          else      dshift=0;

          p=(char*)idata+x/2;
         }
         else
         if(count<0) break;
         else                           /* goto absolute mode */
         {
          pad=(count/2) & 0x1;
          state=STABS;
          sshift=4;
         }
        }
        else
        if(count<0) break;
        else
        {
         state=STRUN;
         bf_getc(&bf,&c);
         sshift=4;
        }
       }
      }
     }
    }
   }
  }
  err=bf_close(&bf,err);
 }

 return(err);

}








os_error * bmppaint(void * bmpdata,int ox,int oy,int w,int h)
{
 void       * bits;
 bmpstr     * bmp;
 BITMAPINFO * bmi;

 bmp=(bmpstr*)(((char*)bmpdata)+2);
 bits=(void*)(((char*)bmpdata)+bmp->hdr.offbits);
 bmi=(BITMAPINFO*)(((char*)bmpdata)+14);

// cprintf("x %x y %x ",bmp->info.windows.cx,bmp->info.windows.cy);

 SetStretchBltMode(currenthdcptr->hdc,COLORONCOLOR);

 StretchDIBits(currenthdcptr->hdc,
               ox,             // x-coordinate of upper-left corner of dest. rectangle
               oy+h,           // y-coordinate of upper-left corner of dest. rectangle
               w,              // width of destination rectangle
               -h,             // height of destination rectangle
               0,              // x-coordinate of upper-left corner of source rectangle
               0,              // y-coordinate of upper-left corner of source rectangle
               bmp->info.windows.cx,            // width of source rectangle
               bmp->info.windows.cy,            // height of source rectangle
               bits,           // address of bitmap bits
               bmi,            // address of bitmap data
               DIB_RGB_COLORS, // usage flags
               SRCCOPY         // raster operation code
              );

 return(NULL);
}




os_error * bmpgetframedata(framestr * frame,void * bmpdata)
{
 void       * bits;
 bmpstr     * bmp;
 char       * p;
 int          r;
 int          g;
 int          b;
 int          bpp;
 int          colours;
 int          xpix;
 int          i;
 int        * w;
 int          rmask;
 int          gmask;
 int          bmask;
 int          rshift;
 int          gshift;
 int          bshift;



 memset(frame,0,sizeof(framestr));

 bmp=(bmpstr*)(((char*)bmpdata)+2);
 bits=(void*)(((char*)bmpdata)+bmp->hdr.offbits);

 frame->planes=1;

 frame->im[0].data=(int*)bits;

 if(bmp->hdr.cbfix==C_OS2)
 {
  frame->im[0].xpix=xpix=bmp->info.os2.cx;
  frame->im[0].ypix=bmp->info.os2.cy;
  frame->im[0].xdpi=96;
  frame->im[0].ydpi=96;
  frame->im[0].bpp=bpp=bmp->info.os2.bitcount;

  if(bpp>8) colours=0;
  else      colours=(1<<bpp);

  p=(char*)(((char*)bmp)+8);

  for(i=0;i<colours;i++)
  {
   b=*p++;
   g=*p++;
   r=*p++;
   frame->im[0].ipal.word[i]=(r<<16)|(g<<8)|(b<<0);
  }

  frame->im[IM].ipal.ncolours=colours;
  frame->im[IM].ipal.palclass=CL_RGB;
 }
 else
 {
  frame->im[0].xpix=xpix=bmp->info.windows.cx;
  frame->im[0].ypix=bmp->info.windows.cy;
  if(frame->im[0].ypix<0)
  {
   frame->im[0].ypix=-frame->im[0].ypix;
   frame->im[0].topdown=1;
  }

  frame->im[0].xdpi=scale(bmp->info.windows.xdpm,254,10000);
  if(frame->im[0].xdpi<=0) frame->im[0].xdpi=96;
  frame->im[0].ydpi=scale(bmp->info.windows.ydpm,254,10000);
  if(frame->im[0].ydpi<=0) frame->im[0].ydpi=96;
  frame->im[0].bpp=bpp=bmp->info.windows.bitcount;

  p=(char*)(((char*)bmp)+bmp->hdr.cbfix+12);

  colours=bmp->info.windows.ncolourused;
  if(bpp<=8)
  {
   if(colours==0) colours=(1<<bpp);

   for(i=0;i<colours;i++)
   {
    b=*p++;
    g=*p++;
    r=*p++;
    frame->im[0].ipal.word[i]=(b<<0)|(g<<8)|(r<<16);
    p++;
   }
  }
  else
  {
   colours=0;

   if(bmp->info.windows.compression==BI_BITFIELDS)
   {
    w=(int*)(((char*)bmp)+bmp->hdr.cbfix+12);

    if(bmp->hdr.cbfix==C_WIN4 || bmp->hdr.cbfix==C_WIN5)
    {
     rmask=bmp->info.windows4.bV4RedMask;
     gmask=bmp->info.windows4.bV4GreenMask;
     bmask=bmp->info.windows4.bV4BlueMask;
    }
    else
    {
     rmask=*w++;
     gmask=*w++;
     bmask=*w++;
    }

    setbitmask(bpp,rmask,&rshift);
    setbitmask(bpp,gmask,&gshift);
    setbitmask(bpp,bmask,&bshift);

    if((bpp==16 && !(rmask==0x7C00 && gmask==0x3E0 && bmask==0x1F)) ||
       (bpp==32 && !(rmask==0xFF0000 && gmask==0xFF00 && bmask==0xFF))
      )
    {
     frame->im[IM].usergbmask=1;
     frame->im[IM].rmask=rmask;
     frame->im[IM].gmask=gmask;
     frame->im[IM].bmask=bmask;
     frame->im[IM].rshift=rshift;
     frame->im[IM].gshift=gshift;
     frame->im[IM].bshift=bshift;
    }

//    cprintf("rmask %x gmask %x bmask %x",rmask,gmask,bmask);
   }
  }
 
  frame->im[IM].ipal.ncolours=colours;
  frame->im[IM].ipal.palclass=CL_RGB;
 }

 frame->im[IM].wwidth=((bpp*xpix+31)&(~31))/8;


 return(NULL);
}




os_error * bmppaintbox(void * bmpdata,coordstr * cx,processstr * pr)
{
 os_error * err;
 POINT      pts[4];
 int        i;
 int        regular;
 int        process;
 framestr   frame;


 bmpgetframedata(&frame,bmpdata);

 for(i=0;i<4;i++)
 {
  pts[i].x=GRDXPIX(cx[i].x);
  pts[i].y=GRDYPIX(cx[i].y);
 }

// LPtoDP(currenthdcptr->hdc,pts,4);

// graphicsostext2(currenthdcptr);

 regular=(pts[0].y==pts[1].y && pts[2].y==pts[3].y &&
          pts[0].x==pts[3].x && pts[1].x==pts[2].x);

 process=(pr && pr->mode!=PROCESSNONE);

// in aid of taking out scaled images with -ve height for LJ printers
// if(pr && pr->isprinter)
// {
//  if(((pts[3].y-pts[0].y)>0 && !frame.im[IM].topdown) ||
//     ((pts[3].y-pts[0].y)<0 && frame.im[IM].topdown)) regular=0;
// }


	if(regular && !process)
	{
  err=impaint(&frame,pts[0].x,pts[0].y,pts[1].x-pts[0].x,pts[3].y-pts[0].y);   // x,y top left of sprite
	}
	else
	if(!regular && !process && 0)
	{
//		err=imrenderparallel(&frame,currenthdcptr,pts);
	}
	else
	{
  err=imrenderbox(&frame,currenthdcptr,pts,pr);
	}


// graphicsriscos2(currenthdcptr);
  
 return(NULL);
}







static char explode[16]=
{
 0x00,  /* 0x0 */
 0x10,  /* 0x1 */
 0x20,
 0x30,

 0x01,
 0x11,
 0x21,
 0x31,

 0x02,
 0x12,
 0x22,
 0x32,

 0x03,
 0x13,
 0x23,
 0x33
};


os_error * savebmp(char * name,imagestr * saveimage)
{
 os_error * err;
 buffer      bf;
 bmpstr      bmp;
 int         xpix;
 int         ypix;
 int         bpp;
 int         obpp;
 int         hdrsize;
 int         infosize;
 int         palsize;
 int         bitsize;
 int         wwidth;
 char      * p;
 char      * q;
 char      * temp;
 int         i;
 int         palword;
 int         y;
 int       * idata;
 int         ch;
 int         colours;
 int         x;
 int         xdpi;
 int         ydpi;
 int         mk24=0;
 int         os2=0;
 int         type=0;


 err=bf_open(name,'w',DEFBUFFSIZE,&bf);
 if(!err)
 {

  xpix=saveimage->xpix;
  ypix=saveimage->ypix;
  xdpi=saveimage->xdpi;
  ydpi=saveimage->ydpi;
  bpp=saveimage->bpp;

  if((bpp==16 || bpp==32) && mk24) obpp=24;
  else                             obpp=(bpp==2)?4:bpp;

  if(obpp>8) colours=0;
  else       colours=(1<<obpp);

  hdrsize=sizeof(bmphdrstr)+2;
  infosize=(os2?C_OS2:C_WIN)-4;
  palsize=os2?(3*colours):(4*colours);
  wwidth=((xpix*obpp+31)&~0x1F)>>3;

  bitsize=wwidth*ypix;

  bmp.hdr.cbsize=hdrsize+infosize+palsize+bitsize;
  bmp.hdr.xhotspot=0;
  bmp.hdr.yhotspot=0;
  bmp.hdr.offbits=hdrsize+infosize+palsize;    
  bmp.hdr.cbfix=infosize+4;

  if(os2)
  {
   bmp.info.os2.cx=(short int)xpix;
   bmp.info.os2.cy=(short int)ypix;
   bmp.info.os2.cplanes=1;
   bmp.info.os2.bitcount=(short int)obpp;
  }
  else
  {
   bmp.info.windows.cx=xpix;
   bmp.info.windows.cy=ypix;
   bmp.info.windows.cplanes=1;
   bmp.info.windows.bitcount=(short int)obpp;
   bmp.info.windows.compression=BI_RGB;
   bmp.info.windows.imagesize=0;
   bmp.info.windows.xdpm=(xdpi*10000)/254;
   bmp.info.windows.ydpm=(ydpi*10000)/254;
   bmp.info.windows.ncolourused=0;
   bmp.info.windows.ncolourimportant=0;
  }

  bf_putc(&bf,'B');
  bf_putc(&bf,'M');

  bf_write(&bf,&bmp,hdrsize-2+infosize);

  for(i=0;i<colours;i++)
  {
   palword=saveimage->ipal.word[i];

   bf_putc(&bf,(palword>>24)&0xFF);
   bf_putc(&bf,(palword>>16)&0xFF);
   bf_putc(&bf,(palword>>8)&0xFF);
   if(!os2) bf_putc(&bf,0);
  }

  if(obpp==1 || obpp==4 || bpp==16 || bpp==32 || bpp==24)
                                    err=flex_alloc((flex_ptr)&temp,wwidth);
  else                              temp=NULL;

  if(!err)
  {
   for(y=(ypix-1);y>=0;y--)
   {
    err=imfind1r(saveimage,y,&idata);
    if(err) break;

    if(bpp==32)
    {
     q=temp;
     if(mk24)
     {
      for(x=0;x<xpix;x++)
      {
       ch=*idata++;
       *q++=(char)(ch>>16);
       *q++=(char)(ch>>8);
       *q++=(char)ch;
      }
     }
     else
     {
      for(x=0;x<xpix;x++)
      {
       ch=*idata++;
       *q++=(char)(ch>>16);
       *q++=(char)(ch>>8);
       *q++=(char)ch;
       *q++=0;
      }
     }
     err=bf_write(&bf,temp,wwidth);
    }
    else
    if(bpp==16)
    {
     q=temp;

     if(mk24)
     {
      for(x=0;x<xpix;x++)
      {
       ch=*idata++;

       *q++=(char)((ch>>7)&0xF8);
       *q++=(char)((ch>>2)&0xF8);
       *q++=(char)((ch<<3)&0xF8);

       x++;
       if(x>=xpix) break;

       *q++=(char)((ch>>23)&0xF8);
       *q++=(char)((ch>>18)&0xF8);
       *q++=(char)((ch>>13)&0xF8);
      }
     }
     else
     {
      for(x=0;x<xpix;x++)
      {
       ch=*idata++;

       ch=((ch & 0x1F)<<10)|(ch & 0x3E0)|((ch & 0x7C00)>>10)|
          ((ch & 0x1F0000)<<10)|(ch & 0x3E00000)|((ch & 0x7C000000)>>10);

       (*((int*)q))=ch;
       q+=4;
      }
     }
     err=bf_write(&bf,temp,wwidth);
    }
    else
    if(bpp==24)
    {
     q=temp;
     p=(char*)idata;

     for(x=0;x<xpix;x++)
     {
      *q++=*(p+2);
      *q++=*(p+1);
      *q++=*p;
      p+=3;
     }

     err=bf_write(&bf,temp,wwidth);
    }
    else
    if(bpp==8) err=bf_write(&bf,idata,wwidth);
    else
    if(bpp==1)
    {
     q=temp;
     p=(char*)idata;
//     for(i=0;i<wwidth;i++) *q++=bitrev[*p++];
//     err=bf_write(&bf,temp,wwidth);
     err=bf_write(&bf,p,wwidth);
    }
    else
    if(bpp==4)
    {
     q=temp;
     p=(char*)idata;
//     for(i=0;i<wwidth;i++) *q++=nybrev[*p++];
//     err=bf_write(&bf,temp,wwidth);
     err=bf_write(&bf,p,wwidth);
    }
    else
    if(obpp==4)
    {
     q=temp;
     p=(char*)idata;
     for(i=0;i<wwidth;i++)
     {
      ch=*p++;
      *q++=explode[ch & 0xF];
      *q++=explode[ch>>4];
     }
     err=bf_write(&bf,temp,wwidth);
    }
   }

   if(temp) flex_free((flex_ptr)&temp);
  }
  err=bf_closec(&bf,err,name,type);
 }
 return(err);
}

