#include "stdafx.h"




#include "etc.h"

#include "getmatch.h"




/*

; MACRO ColErr
;
; Calculates an error value in $error corresponding to the difference
; between the two colours $col1 and $col2.  Requires two temporary
; registers.  All registers must be different.  This routine requires
; 16 instructions, three of which are multiples plus for instructions
; for the error loading calculations.  To speed up the multiplies
; the error value for each component is made positive.
;
; The error calculation is controlled by the following ``loading'' values.
; The basic component error calculation, given components c1 and c2 from
; $col1 and $col2, is:-
;
;       e := ((c1-c2) ^ 2) * load
;
; Thus a higher ``load'' makes errors in the component more significant when
; the component value itself is small, however has little effect when the
; component value is large.  Each loading must not exceed 65536/3 or the
; error calculation may overflow.  If a loading exceeds 32768/3 the result may
; have the top bit set.  The loadings are determined algorithmically by the
; following macros - this avoids having to do a real multiplication.  The
; macros have the form:-
;
;       XWeight $err, $sqr
;
; and calculate:-
;
;       $err = $sqr * XLoad     (for BLoad)
;       $err += $sqr * XLoad    (for GLoad, RLoad)
;
; $sqr may be overwritten.  They are called in the order BLoad, GLoad
; RLoad, and are only called if the corresponding loading value is not
; 1.
;
BLoad   EQU     1
        MACRO
$label  BWeight $error, $sqr
        ASSERT  0
        MEND

GLoad   EQU     10
        MACRO
$label  GWeight $error, $sqr
$label  ADD     $sqr, $sqr, $sqr, LSL #2
        ADD     $error, $error, $sqr, LSL #1
        MEND

RLoad   EQU     3
        MACRO
$label  RWeight $error, $sqr
$label  ADD     $sqr, $sqr, $sqr, LSL #1
        ADD     $error, $error, $sqr
        MEND

        MACRO
$label  ColErr  $error, $col1, $col2, $temp1, $temp2

$label  MOV     $temp1, $col1, LSR #24
        SUBS    $temp2, $temp1, $col2, LSR #24
        RSBLT   $temp2, $temp2, #0
   [    BLoad /= 1
        MUL     $temp1, $temp2, $temp2
        BWeight $error, $temp1
   |
        MUL     $error, $temp2, $temp2
   ]
        MOV     $temp2, #255
        AND     $temp1, $temp2, $col1, LSR #16
        AND     $temp2, $temp2, $col2, LSR #16
        SUBS    $temp2, $temp1, $temp2
        RSBLT   $temp2, $temp2, #0
   [    GLoad /= 1
        MUL     $temp1, $temp2, $temp2
        GWeight $error, $temp1
   |
        MLA     $error, $temp2, $temp2, $error
   ]
        MOV     $temp2, #255
        AND     $temp1, $temp2, $col1, LSR #8
        AND     $temp2, $temp2, $col2, LSR #8
        SUBS    $temp2, $temp1, $temp2
        RSBLT   $temp2, $temp2, #0
   [    RLoad /= 1
        MUL     $temp1, $temp2, $temp2
        RWeight $error, $temp1
   |
        MLA     $error, $temp2, $temp2, $error
   ]
        MEND

*/

#define BWEIGHT 1
#define GWEIGHT 10
#define RWEIGHT 3

unsigned int colerror(int col1,int col2)
{
 unsigned int sum;
 int temp;

 temp=((col1>>8)&0xFF)-((col2>>8)&0xFF);
 sum=temp*temp*RWEIGHT;

 temp=((col1>>16)&0xFF)-((col2>>16)&0xFF);
 sum+=temp*temp*GWEIGHT;

 temp=((col1>>24)&0xFF)-((col2>>24)&0xFF);
 sum+=temp*temp*BWEIGHT;

 return(sum);
}





int getmatch(int * paltab,int * endtab,int pal)
{
 unsigned int  error=MAXINT;
 unsigned int  temp;
 int           index=0;
 int         * palp;

 index=0;
 palp=paltab;

 while(palp<=endtab)
 {
  temp=colerror(*palp,pal);
  if(temp<error)
  {
   error=temp;
   index=palp-paltab;
  }
  palp++;
 }

 return(index);
}

