

#include <stdafx.h>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <malloc.h>

#include "commdlg.h"

#include "os.h"
#include "wimp.h"
#include "flex.h"
#include "alloc.h"
#include "transform.h"
#include "font.h"
#include "wos.h"
#include "poll.h"

#include "osglue.h"
#include "osgraphics.h"
#include "colour.h"
#include "xmath.h"
#include "osunits.h"
#include "etc.h"
#include "deb.h"
#include "osglue.h"
#include "oserr.h"
#include "osreg.h"
#include "trans.h"
#include "oserr.h"
#include "err.h"
#include "fsx.h"
#include "bits.h"

#include "icm.h"
#include "oscms.h"


#include "osprint.h"





static BOOL IsDCPostscript(HDC hDC)
{
	int		nEscapeCode;
	TCHAR	szTechnology[MAX_PATH] = TEXT("");



	// If it supports POSTSCRIPT_PASSTHROUGH, it must be PS.
	nEscapeCode = POSTSCRIPT_PASSTHROUGH;
	if( ExtEscape( hDC, QUERYESCSUPPORT, sizeof(int), (LPCSTR)&nEscapeCode, 0, NULL ) > 0 )
		return TRUE;

	// If it doesn't support GETTECHNOLOGY, we won't be able to tell.
	nEscapeCode = GETTECHNOLOGY;
	if( ExtEscape( hDC, QUERYESCSUPPORT, sizeof(int), (LPCSTR)&nEscapeCode, 0, NULL ) <= 0 )
		return FALSE;

	// Get the technology string and check to see if the word "postscript" is in it.
	if( ExtEscape( hDC, GETTECHNOLOGY, 0, NULL, MAX_PATH, (LPSTR)szTechnology ) <= 0 )
		return FALSE;
	_strupr( szTechnology );
	if( strstr( szTechnology, "POSTSCRIPT" ) != NULL ) return TRUE;

	// The word "postscript" was not found and it didn't support 
	//   POSTSCRIPT_PASSTHROUGH, so it's not a PS printer.
	return FALSE;

}


#define GET_PS_FEATURESETTING        4121   /* new escape for NT5 pscript driver */


#define FEATURESETTING_NUP                  0
#define FEATURESETTING_OUTPUT               1
#define FEATURESETTING_PSLEVEL              2
#define FEATURESETTING_CUSTPAPER            3
#define FEATURESETTING_MIRROR               4
#define FEATURESETTING_NEGATIVE             5
#define FEATURESETTING_PROTOCOL             6


// problem MSDN says feature setting only works in PS or GDI centric modes


static int GetPSLevel(HDC hdc)
{
	int		nEscapeCode;
 int  level;

#ifdef NEVER

	cprintf("PS ident?");

	nEscapeCode=POSTSCRIPT_IDENTIFY;
 if(ExtEscape(hdc,QUERYESCSUPPORT,sizeof(int),(LPCSTR)&nEscapeCode,0,NULL)==0) return(0);

	cprintf("PS GDI");

 nEscapeCode=PSIDENT_GDICENTRIC;
 if(ExtEscape(hdc,POSTSCRIPT_IDENTIFY,sizeof(int),(LPCSTR)&nEscapeCode,0,NULL)==0) return(0);

#endif

	nEscapeCode=GET_PS_FEATURESETTING;

// int code=ExtEscape(hdc,QUERYESCSUPPORT,sizeof(int),(LPCSTR)&nEscapeCode,0,NULL );
//	cprintf("get ps level code esc support %d",code);

	if(ExtEscape(hdc,QUERYESCSUPPORT,sizeof(int),(LPCSTR)&nEscapeCode,0,NULL )<=0) return(0);

 nEscapeCode=FEATURESETTING_PSLEVEL;
 if(ExtEscape(hdc,GET_PS_FEATURESETTING,sizeof(int),(LPCSTR)&nEscapeCode,sizeof(int),(LPSTR)&level)>0)
 {
  return(level);
 }

 return(0);
}



#ifdef NEVER

 DWORD                   dwNeeded;
 static DWORD            nmax=0;
 static PRINTER_INFO_1 * pinfo1=NULL;
// static PRINTER_INFO_4 * pinfo4=NULL;
// static PRINTER_INFO_5 * pinfo5=NULL; 

 USE(len);

 if(n==0)
 {
#ifdef NEVER
  if(ISW9X)         // Windows 98
  {
   if(pinfo5) free(pinfo5);
   
   EnumPrinters(PRINTER_ENUM_LOCAL,NULL,5,NULL,0,&dwNeeded,&nmax);

   pinfo5=(PRINTER_INFO_5*)malloc(dwNeeded);

   EnumPrinters(PRINTER_ENUM_LOCAL,NULL,5,(PBYTE)pinfo5,dwNeeded,&dwNeeded,&nmax);
  }
  else                                  // Windows NT
  {
   if(pinfo4) free(pinfo4);
   
   EnumPrinters(PRINTER_ENUM_LOCAL,NULL,4,NULL,0,&dwNeeded,&nmax);

   pinfo4=(PRINTER_INFO_4*)malloc(dwNeeded);
   nmax=dwNeeded/sizeof(PRINTER_INFO_4);

   EnumPrinters(PRINTER_ENUM_LOCAL,NULL,4,(PBYTE)pinfo4,dwNeeded,&dwNeeded,&nmax);
  }
#endif

 }


 if(pinfo1) free(pinfo1);
   
 EnumPrinters(PRINTER_ENUM_NAME,"Windows NT Remote Printers",1,NULL,0,&dwNeeded,&nmax);
// EnumPrinters(PRINTER_ENUM_NAME,NULL,1,NULL,0,&dwNeeded,&nmax);

 pinfo1=(PRINTER_INFO_1*)malloc(dwNeeded);
 nmax=dwNeeded/sizeof(PRINTER_INFO_1);

 EnumPrinters(PRINTER_ENUM_NAME,"Windows NT Remote Printers",1,(PBYTE)pinfo1,dwNeeded,&dwNeeded,&nmax);
// EnumPrinters(PRINTER_ENUM_NAME,NULL,1,(PBYTE)pinfo1,dwNeeded,&dwNeeded,&nmax);


#endif




static void * osprnames;
static void * osprmap;


typedef struct osprnamestr
{
 int name;

} osprnamestr;


static int osprmapcmp(void * key1,void * key2)
{
 return(cstrcmp(stringheapstring(osprnames,((osprnamestr*)key1)->name),stringheapstring(osprnames,((osprnamestr*)key2)->name)));
}



os_error * osenumprinter(char * name)
{
 DWORD            nmax;
 int              i;
 DWORD            dwNeeded;
 PRINTER_INFO_1 * pinfo1;
 int              offset;
 osprnamestr      prname;


 EnumPrinters(PRINTER_ENUM_LOCAL | PRINTER_ENUM_CONNECTIONS,name,1,NULL,0,&dwNeeded,&nmax);

 nmax=dwNeeded/sizeof(PRINTER_INFO_1);
 if(nmax)
 {
  pinfo1=(PRINTER_INFO_1*)malloc(dwNeeded);
  EnumPrinters(PRINTER_ENUM_LOCAL | PRINTER_ENUM_CONNECTIONS,name,1,(PBYTE)pinfo1,dwNeeded,&dwNeeded,&nmax);

  for(i=0;i<(signed int)nmax;i++)
  {
   if(pinfo1[i].Flags & (PRINTER_ENUM_EXPAND|PRINTER_ENUM_CONTAINER))
   {
    osenumprinter(pinfo1[i].pName);
   }
   else
   {
    stringheapadd(&osprnames,pinfo1[i].pName,&offset);
    prname.name=offset;
    xmapadd(&prname,&osprmap);
   }
  }

  free(pinfo1);
 }

 return(NULL);
}






os_error * osprgetnamen(int n,char * string,int len)
{
 osprnamestr * prname;

 *string=0;

 if(n==0)
 {
  stringheapfinit(&osprnames);
  stringheapinit(&osprnames,256);

  xmapfinit(&osprmap);
  xmapinit(&osprmap,sizeof(osprnamestr),16,osprmapcmp);

  osenumprinter(NULL);
 }

 prname=(osprnamestr *)xmaprecord(osprmap,n);
 if(prname)
 {
  xzstrncpy(string,stringheapstring(osprnames,prname->name),len);
 }

 return(NULL);
}







os_error * osprgetdefaultname(char * string,int len)
{
	os_error       * err;
 DWORD            dwNeeded;
 DWORD            dwReturned; 
 PRINTER_INFO_5 * pinfo5; 

	err=NULL;


	*string=0;

 if(ISW9X)         // Windows 98
 {
  EnumPrinters(PRINTER_ENUM_DEFAULT,NULL,5,NULL,0,&dwNeeded,&dwReturned);
		if(dwNeeded!=0)
		{
   pinfo5=(PRINTER_INFO_5 *)malloc(dwNeeded);

   EnumPrinters(PRINTER_ENUM_DEFAULT,NULL,5,(PBYTE)pinfo5,dwNeeded,&dwNeeded,&dwReturned);

   err=xzstrncpye(string,pinfo5->pPrinterName,len);

   free(pinfo5);
		}
 }
 else                                    // Windows NT
 {
  char cBuffer[MAX_PATH];

  *string=0;

  if(GetProfileString("windows", "device", ",,,", cBuffer,sizeof(cBuffer)/sizeof(TCHAR))>0)
  {    
   // Printer name precedes first "," character...
   if(*cBuffer==',' || *cBuffer==0)
   {


   }
   else
   {
    strtok(cBuffer,",");
   // Copy printer name into passed-in buffer...
    err=xzstrncpye(string,cBuffer,len);
   }
  }
 }

 return(err);
}



static HANDLE hDevMode;
static HANDLE hDevNames;

static RECT   rcMargin;
static int    rcflags;

static os_error * GetDevMode(void)
{
 PAGESETUPDLG ps;
    
 ZeroMemory(&ps, sizeof ps);
 ps.lStructSize = sizeof ps;
 ps.Flags = PSD_RETURNDEFAULT;
    
 PageSetupDlg(&ps);
 hDevMode = ps.hDevMode;
 hDevNames = ps.hDevNames;
 
 CopyRect(&rcMargin, &ps.rtMargin);
 rcflags=ps.Flags;

 return(NULL);
}


// if we do this before opening a window, window opens at back

os_error * osprintinitdbox(void)
{

 GetDevMode();

 return(NULL);
}



/*****************************************************************************/


static hdcstr * xprinthdcptr;
static osabortprintfn xabort;
static uservalue      xuserhandle;
static wimp_w         xhandle;
static void         * xdata;
static int            xflags;
static HANDLE         xprinter;
static HDC            xprinthdc;



/*
		PRXRAW drives the printer direct, there is no PS code from Windows at all
		this approach seems to fail with the Adobe PDF printer driver.

		PRXRAW2 uses EPSPRINTING. This gets some Windows PS headers and printer
		feature PS. Essentially you're put at the start of a page and allowed to get
  on with it. After you finish Windows will do a showpage and output info.
		There are two approaches to handling multiple pages. Either call StartPage()
  and EndPage() but you then have to output document procedures for each page,
  or make use of the facility to merge them into the Window procs at the start
  of the doc. Or put out all the pages in one go, using showpage between them.



*/


os_error * osgoprinter(void)
{
 if(xflags & PRXRAW)
 {

 }
 else
 if(xflags & PRXRAW2)
 {


 }
 else
 {
  graphicssetcurrent(xprinthdcptr);
  vduenterprintmode(xprinthdcptr);
 }

 return(NULL);
}


os_error * osgonormal(void)
{

 if(xflags & PRXRAW)
 {

 }
 else
 if(xflags & PRXRAW2)
 {


 }
 else
 {
  graphicsclearcurrent(xprinthdcptr);
  vduexitprintmode();
 }

 return(NULL);
}




static os_error * rawwrite(char * dp,int len)
{
 DWORD      dwBytesWritten;

 WritePrinter(xprinter,dp,len,&dwBytesWritten);

	if((unsigned)len!=dwBytesWritten) cprintf("rawwrite error");

 return(NULL);
}



static os_error * driverwrite(char * dp,int len)
{ 
 char data[4096];
 int  size;

 data[0]=(char)(len&0xFF);
 data[1]=(char)((len>>8)&0xFF);
 XMEMCPYX(data+2,dp,len);

 size=2+len;

 ExtEscape(xprinthdcptr->hdc,PASSTHROUGH,size,data,0,NULL);

 return(NULL);
}



#define DRIVERSIZE 4096

static char * driverbuffer;
static char * driverptr;
static char * driverlt;





static os_error * driverbufferinit(void)
{
 os_error * err;

 err=NULL;

 if(!driverbuffer) err=salloc((flex_ptr)&driverbuffer,DRIVERSIZE);

 if(!err)
 {
  driverptr=driverbuffer+2;
  driverlt=driverbuffer+DRIVERSIZE;
 }

 return(err);
}


static os_error * driverbufferfinit(void)
{

 return(sfree((flex_ptr)&driverbuffer));
}


static os_error * driverbufferflush(void)
{
 os_error * err;
 int        len;


 err=NULL;

 len=(driverptr-(driverbuffer+2));
 if(len)
 {
  driverbuffer[0]=(char)(len&0xFF);
  driverbuffer[1]=(char)((len>>8)&0xFF);

  ExtEscape(xprinthdc,PASSTHROUGH,len+2,driverbuffer,0,NULL);

  driverptr=driverbuffer+2;
 }

 return(err);
}


static os_error * driverwrite2(char * dp,int len)
{ 
 os_error * err;

 err=NULL;

 if((driverlt-driverptr)<len) err=driverbufferflush();

 if(len<DRIVERSIZE)
 {
  XMEMCPYX(driverptr,dp,len);
  driverptr+=len;
 }

 return(err);
}


os_error * oswriteprinterdata(char * dp,int len)
{
 if(xflags & PRXRAW)  return(rawwrite(dp,len));
 else
 if(xflags & PRXRAW2) return(driverwrite2(dp,len));
 else                 return(driverwrite(dp,len));
}
 

os_error * oswriteprinter(char * string)
{
 return(oswriteprinterdata(string,strlen(string)));
}


os_error * oswriteprinterf(char * format,...)
{
 os_error * err;
 va_list    args;
 char       v[4096];
 int        len;

 va_start(args,format);
 VSNPRINTF(v,sizeof(v)/sizeof(TCHAR),format,args,len);
 va_end(args);


 err=oswriteprinter(v);

 return(err);
}


os_error * osprintstartdoc(char * docname,char * filename)
{
 os_error * err;

	err=NULL;

 if(xflags & PRXRAW)
 {
  DOC_INFO_1 DocInfo;

  DocInfo.pDocName=docname;
  DocInfo.pOutputFile=filename;
  DocInfo.pDatatype=TEXT("RAW");

  err=XStartDocPrinter(xprinter,1,(unsigned char *)&DocInfo,NULL);
 }
 else
 if(xflags & PRXRAW2)
 {
  DOCINFO    di;

  driverbufferinit();

  memset(&di,0,sizeof(di));
  di.cbSize=sizeof(di);
  di.lpszDocName=docname;
  di.lpszOutput=filename;
  di.lpszDatatype=TEXT("RAW");

  err=XStartDoc(xprinthdc,&di,NULL);
 }
 else
 {
  DOCINFO    di;

  memset(&di,0,sizeof(di));
  di.cbSize=sizeof(di);
  di.lpszDocName=docname;
  di.lpszOutput=filename;

  err=XStartDoc(xprinthdcptr->hdc,&di,NULL);
 }

 cprintf("startdoc %s filename %s",docname,filename);
	if(err) cprintf("startdoc err %s",err->errmess);

 return(err);
}




os_error * osprintenddoc(void)
{
 if(xflags & PRXRAW)
 {
  EndDocPrinter(xprinter);
 }
 else
 if(xflags & PRXRAW2)
 {
  driverbufferflush();
  EndDoc(xprinthdc);
  driverbufferfinit();
 }
 else
 {
  EndDoc(xprinthdcptr->hdc);
 }

 return(NULL);
}


os_error * osprintabortdoc(void)
{
 if(xflags & PRXRAW)
 {

 }
 else
 if(xflags & PRXRAW2)
 {

 }
 else
 {
  AbortDoc(xprinthdcptr->hdc);
 }

 return(NULL);
}



os_error * osprintstartpage(void)
{
 if(xflags & PRXRAW)
 {
  StartPagePrinter(xprinter);
 }
 else
 if(xflags & PRXRAW2)
 {
  cprintf("raw2 start page");
// driverbufferflush();
//  StartPage(xprinthdc);
 }
 else
 {
  StartPage(xprinthdcptr->hdc);
 }

 return(NULL);
}



os_error * osprintendpage(void)
{
 if(xflags & PRXRAW)
 {
  EndPagePrinter(xprinter);
 }
 else
 if(xflags & PRXRAW2)
 {
// driverbufferflush();
//  EndPage(xprinthdc);
 }
 else
 {
  EndPage(xprinthdcptr->hdc);
 }

 return(NULL);
}



/*

Return Values
The callback function should return TRUE to continue the print job or FALSE to cancel the print job. 

Remarks
If the iError parameter is SP_OUTOFDISK, the application need not cancel the print job. If it does not cancel the job, it must yield to Print Manager by calling the PeekMessage or GetMessage function

*/



static BOOL CALLBACK AbortProc(HDC hdc,int iError)
{
 int zflags;

 zflags=TRUE;

 if(xabort) xabort(xhandle,xuserhandle,NULL,&zflags);

 return(zflags);

 USE(iError);
 USE(hdc);
}





static os_error * osprintdc(HDC hdc,osprintfn printfn,osabortprintfn abortfn)
{
 os_error       * err;
 wimp_redrawstr   r;
 hdcstr         * hdcptr;
 int              iPhysOffsetX;
 int              iPhysOffsetY;
 int              iPhysWidth;
 int              iPhysHeight;
	int              height;
 int              xoffset;
	int              yoffset;

 graphicsnewhdc(&hdcptr);
 hdcptr->hdc=hdc;
 xprinthdcptr=hdcptr;

 vduenterprintmode(hdcptr);


 iPhysOffsetX=GetDeviceCaps(hdc,PHYSICALOFFSETX);
 iPhysOffsetY=GetDeviceCaps(hdc,PHYSICALOFFSETY);
 iPhysWidth=GetDeviceCaps(hdc,PHYSICALWIDTH);
 iPhysHeight=GetDeviceCaps(hdc,PHYSICALHEIGHT);

 r.g.x0=xpix2os(iPhysOffsetX);    // set to printable window										x0,y1 top left
 r.g.y1=-ypix2os(iPhysOffsetY);
 r.g.x1=r.g.x0+xpix2os(GetDeviceCaps(hdc,HORZRES));
 r.g.y0=r.g.y1-ypix2os(GetDeviceCaps(hdc,VERTRES));

	height=ypix2os(iPhysHeight);

 r.box.x0=0;                  // set to page size
 r.box.y1=0;
 r.box.x1=xpix2os(iPhysWidth);
 r.box.y0=-height;

 r.scx=0; //xpix2os(iPhysOffsetX);
 r.scy=0; //-ypix2os(iPhysOffsetY);

	xoffset=r.g.x0;
	yoffset=r.g.y1;

// 0,0 is at gx0,gy1

 r.g.x0-=xoffset;
 r.g.y1-=yoffset;
 r.g.x1-=xoffset;
 r.g.y0-=yoffset;

 r.box.x0-=xoffset;
 r.box.y1-=yoffset;
 r.box.x1-=xoffset;
 r.box.y0-=yoffset;



 graphicsinit2(-r.scx,-r.scy,hdcptr);
 graphicssetcurrent(hdcptr);

 if(abortfn)
 {
  SetAbortProc(hdc,AbortProc);
 }

 r.hdcptr=(oshdc)hdcptr;

//os_error * (*osprintfn)(wimp_redrawstr * r,int flags,void * data,int userhandle);
 
 err=printfn(&r,0,xdata,xuserhandle);

 xprinthdcptr=NULL;

 graphicsclearcurrent(hdcptr);
 graphicsfinit2(hdcptr);
 graphicsdeletehdc(hdcptr);

 vduexitprintmode();

 return(err);
}





os_error * osprintdbox(wimp_w parent,wimp_w handle,uservalue userhandle,osprintfn printfn,osabortprintfn abortfn,int flags,int * data)
{
 PRINTDLG         pd;
 wimp_redrawstr   r;
 hdcstr         * hdcptr;
 RECT             margins;
 int              iLeftAdjust;
 int              iTopAdjust;
 int              iRightAdjust;
 int              iBottomAdjust;
 int              iPhysOffsetX;
 int              iPhysOffsetY;
 int              iPhysWidth;
 int              iPhysHeight;
 int              iWidth;
 int              iHeight;
	int              height;
	int              xoffset;
	int              yoffset;

 xabort=abortfn;
 xuserhandle=userhandle;
 xhandle=handle;

 ZeroMemory(&pd,sizeof(pd));
 pd.lStructSize=sizeof pd;     // always remember to set this!
 pd.hInstance=AppInstance;     // application process handle
 pd.hwndOwner=(HWND)parent;
 pd.hDevMode=hDevMode;
 pd.hDevNames=hDevNames;
 pd.Flags=PD_ALLPAGES|PD_HIDEPRINTTOFILE|PD_NOPAGENUMS|PD_RETURNDC;
 pd.nCopies=1;

 if(PrintDlg(&pd))
 {
  graphicsnewhdc(&hdcptr);
  hdcptr->hdc=pd.hDC;
  xprinthdcptr=hdcptr;

  vduenterprintmode(hdcptr);


  if(rcflags & PSD_INTHOUSANDTHSOFINCHES)
  {
   margins.left=MulDiv(rcMargin.left,GetDeviceCaps(pd.hDC,LOGPIXELSX),1000);
   margins.top=MulDiv(rcMargin.top,GetDeviceCaps(pd.hDC,LOGPIXELSY),1000);
   margins.right=MulDiv(rcMargin.right,GetDeviceCaps(pd.hDC,LOGPIXELSX),1000);
   margins.bottom=MulDiv(rcMargin.bottom,GetDeviceCaps(pd.hDC,LOGPIXELSY),1000);
  }
  else  // PSD_INHUNDREDTHSOFMILLIMETERS
  {
   margins.left=MulDiv(rcMargin.left,GetDeviceCaps(pd.hDC,LOGPIXELSX),2540);
   margins.top=MulDiv(rcMargin.top,GetDeviceCaps(pd.hDC,LOGPIXELSY),2540);
   margins.right=MulDiv(rcMargin.right,GetDeviceCaps(pd.hDC,LOGPIXELSX),2540);
   margins.bottom=MulDiv(rcMargin.bottom,GetDeviceCaps(pd.hDC,LOGPIXELSY),2540);
  }


  iPhysOffsetX=GetDeviceCaps(pd.hDC,PHYSICALOFFSETX);
  iPhysOffsetY=GetDeviceCaps(pd.hDC,PHYSICALOFFSETY);
  iPhysWidth=GetDeviceCaps(pd.hDC,PHYSICALWIDTH);
  iPhysHeight=GetDeviceCaps(pd.hDC,PHYSICALHEIGHT);

  iLeftAdjust  =margins.left -iPhysOffsetX;
  iTopAdjust   =margins.top  -iPhysOffsetY;
  iRightAdjust =margins.right-(iPhysWidth-iPhysOffsetX-GetDeviceCaps(pd.hDC,HORZRES));
  iBottomAdjust=margins.right-(iPhysHeight-iPhysOffsetY-GetDeviceCaps(pd.hDC,VERTRES));

  iWidth =GetDeviceCaps(pd.hDC,HORZRES)-(iLeftAdjust+iRightAdjust);
  iHeight=GetDeviceCaps(pd.hDC,VERTRES)-(iTopAdjust+iBottomAdjust);


  r.g.x0=xpix2os(iPhysOffsetX);         // set to printable window
  r.g.y1=-ypix2os(iPhysOffsetY);
  r.g.x1=r.g.x0+xpix2os(GetDeviceCaps(pd.hDC,HORZRES));
  r.g.y0=r.g.y1-ypix2os(GetDeviceCaps(pd.hDC,VERTRES));

		height=ypix2os(iPhysHeight);

  r.box.x0=0;                  // set to page size
  r.box.y1=0;
  r.box.x1=xpix2os(iPhysWidth);
  r.box.y0=-height;

  r.scx=0; //xpix2os(iPhysOffsetX);
  r.scy=0; //-ypix2os(iPhysOffsetY); 


 	xoffset=r.g.x0;
 	yoffset=r.g.y1;

// 0,0 is at gx0,gy1

  r.g.x0-=xoffset;
  r.g.y1-=yoffset;
  r.g.x1-=xoffset;
  r.g.y0-=yoffset;

  r.box.x0-=xoffset;
  r.box.y1-=yoffset;
  r.box.x1-=xoffset;
  r.box.y0-=yoffset;


  graphicsinit2(-r.scx,-r.scy,hdcptr);
  graphicssetcurrent(hdcptr);

  if(abortfn)
  {
   SetAbortProc(pd.hDC,AbortProc);
  }

  r.hdcptr=(oshdc)hdcptr;
  printfn(&r,0,NULL,0);

  xprinthdcptr=NULL;

  graphicsclearcurrent(hdcptr);
  graphicsfinit2(hdcptr);
  graphicsdeletehdc(hdcptr);

  vduexitprintmode();

  DeleteDC(pd.hDC);
 }

 return(NULL);

 USE(data);
 USE(flags);
}


os_error * osprintpagedbox(wimp_w parent)
{
 PAGESETUPDLG psd;

 ZeroMemory(&psd,sizeof(psd));
 psd.lStructSize=sizeof(psd);

 CopyRect(&psd.rtMargin,&rcMargin);

 psd.Flags = PSD_MARGINS | PSD_DEFAULTMINMARGINS;

 psd.hwndOwner=(HWND)parent;
 psd.hDevMode=hDevMode;
 psd.hDevNames=hDevNames;

 PageSetupDlg(&psd);

 CopyRect(&rcMargin, &psd.rtMargin);
 rcflags=psd.Flags;

 return(NULL);
}




os_error * osprintmargins(int * left,int * right,int * top,int * bottom,int xres,int yres)
{
	os_error       * err;
 HDC              hdc;
 int              iPhysOffsetX;
 int              iPhysOffsetY;
 int              Width;
 int              Height;
 int              xdpi;
 int              ydpi;
 DEVNAMES       * devnames;
 DEVMODE        * devmode;


	err=NULL;

	devnames=NULL;
	devmode=NULL;

 if(hDevNames) devnames=(DEVNAMES*)GlobalLock((HGLOBAL*)hDevNames);
 if(hDevMode)  devmode=(DEVMODE*)GlobalLock((HGLOBAL*)hDevMode);

	if(devnames)
	{
  err=XCreateIC(devnames->wDriverOffset+(char*)devnames, // driver name
               devnames->wDeviceOffset+(char*)devnames, // device name
               devnames->wOutputOffset+(char*)devnames, // port or file name
               devmode,                                 // optional initialization data
 														&hdc
              );

 // cprintf("name %s",devnames->wDriverOffset+(char*)devnames);
  
  if(!err)
  {
   xdpi=GetDeviceCaps(hdc,LOGPIXELSX);
   ydpi=GetDeviceCaps(hdc,LOGPIXELSY);
  
   iPhysOffsetX=GetDeviceCaps(hdc,PHYSICALOFFSETX);
   iPhysOffsetY=GetDeviceCaps(hdc,PHYSICALOFFSETY);
   Width=GetDeviceCaps(hdc,HORZRES);
   Height=GetDeviceCaps(hdc,VERTRES);

   *left=scale(iPhysOffsetX,xres,xdpi);
   *right=*left+scale(Width,xres,xdpi);
   *top=scale(iPhysOffsetY,yres,ydpi);
   *bottom=*top+scale(Height,yres,ydpi);

 //  cprintf("osprint x=%d y=%d w=%d h=%d",*left,*right,*top,*bottom);

   err=XDeleteDC(hdc,err);
  }
	}

 if(hDevNames) GlobalUnlock((HGLOBAL*)hDevNames);
 if(hDevMode)  GlobalUnlock((HGLOBAL*)hDevMode);


 return(err);
}



os_error * osprintprofile(int * size,char * buffer)
{
	os_error       * err;
 HDC              hdc;
 DEVNAMES       * devnames;
 DEVMODE        * devmode;

	err=NULL;

	devnames=NULL;
	devmode=NULL;

 if(hDevNames) devnames=(DEVNAMES*)GlobalLock((HGLOBAL*)hDevNames);
 if(hDevMode)  devmode=(DEVMODE*)GlobalLock((HGLOBAL*)hDevMode);

	if(devnames)
	{
  err=XCreateIC(devnames->wDriverOffset+(char*)devnames, // driver name
               devnames->wDeviceOffset+(char*)devnames, // device name
               devnames->wOutputOffset+(char*)devnames, // port or file name
               devmode,                                 // optional initialization data
 														&hdc
              );

 // cprintf("name %s",devnames->wDriverOffset+(char*)devnames);
  
  if(!err)
  {
 		err=XGetDisplayProfile((LPTSTR)buffer,(PDWORD)size);

   err=XDeleteDC(hdc,err);
  }
	}

 if(hDevNames) GlobalUnlock((HGLOBAL*)hDevNames);
 if(hDevMode)  GlobalUnlock((HGLOBAL*)hDevMode);

 return(err);
}








// our own printer functions
// we have to track the printer name
// and the devicemode for it


static char printername[256];

static PDEVMODE pdevmode;

static int      printerps;
static int      printerpslevel;


static os_error * osxprgetproperties(void)
{
	os_error       * err;
 int              size;
 HANDLE           hPrinter;
 HDC              hdc=NULL;
 DWORD            needed;
 PRINTER_INFO_2 * prinfo;

	err=NULL;

	if(*printername)
	{
  err=XOpenPrinter(printername,&hPrinter,NULL);
		if(!err)
		{
   size=DocumentProperties(NULL,hPrinter,printername,NULL,NULL,0);
   if(size>0)
   {
    if(pdevmode) free((void*)pdevmode);
    pdevmode=(PDEVMODE)malloc(size);
    if(pdevmode)
    {
     DocumentProperties(NULL,hPrinter,printername,pdevmode,NULL,DM_OUT_BUFFER);

//     cprintf("pdevmode extra %d size %d total %d",pdevmode->dmDriverExtra,pdevmode->dmSize,size);
//     fs_saveblock("c:\\Temp\\xx.dat",0xFFF,pdevmode,size);


     err=XGetPrinter(hPrinter,2,NULL,0,&needed);
					if(!err)
					{
      prinfo=(PRINTER_INFO_2*)malloc(needed);
      if(prinfo)
      {
       err=XGetPrinter(hPrinter,2,(LPBYTE)prinfo,needed,&needed);
							if(!err) err=XCreateIC(prinfo->pDriverName, // driver name
                    prinfo->pPrinterName,// device name
                    prinfo->pPortName,   // port or file name
                    pdevmode,             // optional initialization data
																				&hdc
                   );
       if(!err)
       {
        printerps=IsDCPostscript(hdc);
        if(printerps)
        {
         printerpslevel=GetPSLevel(hdc);

        }
        cprintf("printerps %d %s",printerps,prinfo->pPortName);
 
        err=XDeleteDC(hdc,err);
       }

       free(prinfo);
						}
     }
    }
   }
   err=XClosePrinter(hPrinter,err);
		}
	}
	else
	{
		err=geterror(ENOPRINTER);
	}

 return(err);
}


os_error * osprgetcurrentname(char * string,int len)
{
 xzstrncpy(string,printername,len);
 return(NULL);
 USE(len);
}


os_error * osprgetcurrenttype(int * type)
{
 *type=printerps?PRPSTYPE:PRNOTYPE;
 return(NULL);
}



os_error * osprinterpslevel(int * level)
{
 *level=printerpslevel;
 return(NULL);
}




os_error * osprsetcurrentname(char * string)
{
	os_error * err;

 err=xzstrncpye(printername,string,sizeof(printername)/sizeof(TCHAR));
	if(!err) err=osxprgetproperties();
 if(!err) wmgeneratemessage(wimp_MPrinterChange);

 return(err);
}



os_error * osxprintinit(void)
{

 osprgetdefaultname(printername,sizeof(printername)/sizeof(TCHAR));
 osxprgetproperties();

 wmgeneratemessage(wimp_MPrintInit);

 return(NULL);
}



os_error * osxprintpropscale(int newscale,int * oldscale,int inmode,int * outmode)
{

 if(outmode) *outmode=0;

 if(pdevmode)
 {
  if(pdevmode->dmFields & DM_SCALE)
  {
   if(inmode & PRPROP_READ) *oldscale=pdevmode->dmScale;
   if(inmode & PRPROP_WRITE) pdevmode->dmScale=(short)newscale;
   if(outmode) *outmode=PRPROP_SET;
  }
 }

 return(NULL);
}



os_error * osxprintpropcopies(int newcopies,int * oldcopies,int inmode,int * outmode)
{

 if(outmode) *outmode=0;

 if(pdevmode)
 {
  if(pdevmode->dmFields & DM_COPIES)
  {
   if(inmode & PRPROP_READ) *oldcopies=pdevmode->dmCopies;
   if(inmode & PRPROP_WRITE) pdevmode->dmCopies=(short)newcopies;
   if(outmode) *outmode=PRPROP_SET;
  }
 }

 return(NULL);
}




os_error * osxprintpropcollate(int newcollate,int * oldcollate,int inmode,int * outmode)
{

 if(outmode) *outmode=0;

 if(pdevmode)
 {
  if(pdevmode->dmFields & DM_COLLATE)
  {
   if(inmode & PRPROP_READ) *oldcollate=(pdevmode->dmCollate==DMCOLLATE_TRUE);
   if(inmode & PRPROP_WRITE) pdevmode->dmCollate=(short)(newcollate?DMCOLLATE_TRUE:DMCOLLATE_FALSE);
   if(outmode) *outmode=PRPROP_SET;
  }
 }

 return(NULL);
}




os_error * osxprintproporient(int neworient,int * oldorient,int inmode,int * outmode)
{

 if(outmode) *outmode=0;

 if(pdevmode)
 {
  if(pdevmode->dmFields & DM_ORIENTATION)
  {
   cprintf("orientation %d",pdevmode->dmOrientation);
   
   if(inmode & PRPROP_READ) *oldorient=(pdevmode->dmOrientation==DMORIENT_LANDSCAPE);
   if(inmode & PRPROP_WRITE) pdevmode->dmOrientation=(short)(neworient?DMORIENT_LANDSCAPE:DMORIENT_PORTRAIT);
   if(outmode) *outmode=PRPROP_SET;
  }
 }

 return(NULL);
}



os_error * osxprintpropttoption(int newttoption,int * oldttoption,int inmode,int * outmode)
{

 if(outmode) *outmode=0;

 if(pdevmode)
 {
  if(pdevmode->dmFields & DM_TTOPTION)
  {
   cprintf("TT option %d",pdevmode->dmTTOption);
   
   if(inmode & PRPROP_READ) *oldttoption=pdevmode->dmTTOption;
   if(inmode & PRPROP_WRITE) pdevmode->dmTTOption=(short)newttoption;
   if(outmode) *outmode=PRPROP_SET;
  }
 }

 return(NULL);
}










os_error * osxprintpropertiesdbox(wimp_w parent,int * okp)
{
	os_error * err;
 int        code;
 HANDLE     phPrinter;

	err=NULL;

 *okp=0;

	if(*printername)
	{
  err=XOpenPrinter(printername,&phPrinter,NULL);
		if(!err)
		{
   code=DocumentProperties((HWND)parent,phPrinter,printername,pdevmode,pdevmode,DM_IN_BUFFER|DM_IN_PROMPT|DM_OUT_BUFFER);

//   fs_saveblock("c:\\Temp\\x1.dat",0xFFF,pdevmode,_msize(pdevmode));
   if(code==IDOK)
   {
    wmgeneratemessage(wimp_MPrinterChange);
   }
   else
   {
    *okp=1;
   }

   err=XClosePrinter(phPrinter,err);
		}
	}
	else
	{
		err=geterror(ENOPRINTER);
	}

 return(err);
}





static os_error * osxgetmargins(int * left,int * right,int * top,int * bottom,int * width,int * height,int xres,int yres,HANDLE hPrinter)
{
	os_error       * err;
 PRINTER_INFO_2 * prinfo;
 HDC              hdc;
 DWORD            needed;
 int              iPhysOffsetX;
 int              iPhysOffsetY;
 int              iPhysWidth;
 int              iPhysHeight;
 int              Width;
 int              Height;
 int              xdpi;
 int              ydpi;




 err=XGetPrinter(hPrinter,2,NULL,0,&needed);
 prinfo=(PRINTER_INFO_2*)malloc(needed);
 err=XGetPrinter(hPrinter,2,(LPBYTE)prinfo,needed,&needed);


 err=XCreateIC(prinfo->pDriverName, // driver name
               prinfo->pPrinterName,// device name
               prinfo->pPortName,   // port or file name
               pdevmode,             // optional initialization data
															&hdc
              );
  
 if(!err)
 {
  xdpi=GetDeviceCaps(hdc,LOGPIXELSX);
  ydpi=GetDeviceCaps(hdc,LOGPIXELSY);
  
  iPhysOffsetX=GetDeviceCaps(hdc,PHYSICALOFFSETX);
  iPhysOffsetY=GetDeviceCaps(hdc,PHYSICALOFFSETY);
  iPhysWidth=GetDeviceCaps(hdc,PHYSICALWIDTH);
  iPhysHeight=GetDeviceCaps(hdc,PHYSICALHEIGHT);
  Width=GetDeviceCaps(hdc,HORZRES);
  Height=GetDeviceCaps(hdc,VERTRES);

  if(left)   *left=scale(iPhysOffsetX,xres,xdpi);
  if(right)  *right=*left+scale(Width,xres,xdpi);
  if(top)    *top=scale(iPhysOffsetY,yres,ydpi);
  if(bottom) *bottom=*top+scale(Height,yres,ydpi);
  if(width)  *width=scale(iPhysWidth,xres,xdpi);
  if(height) *height=scale(iPhysHeight,yres,ydpi);

   cprintf("osxprint x=%d y=%d w=%d h=%d",*left,*right,*top,*bottom);
   cprintf("X %d Y %d",GetDeviceCaps(hdc,SCALINGFACTORX),GetDeviceCaps(hdc,SCALINGFACTORY));

  err=XDeleteDC(hdc,err);
 }

 free(prinfo);

	return(err);
}





static os_error * osxgetmarginsreal(int * left,int * right,int * top,int * bottom,int * width,int * height,int xres,int yres,HANDLE hPrinter)
{
 os_error * err;
 int        oldorient;
 int        oldscale;
 int        orientmode;
 int        scalemode;

 osxprintproporient(0,&oldorient,PRPROP_WRITE|PRPROP_READ,&orientmode);
 osxprintpropscale(100,&oldscale,PRPROP_WRITE|PRPROP_READ,&scalemode);

 err=osxgetmargins(left,right,top,bottom,width,height,xres,yres,hPrinter);

 if(orientmode) osxprintproporient(oldorient,NULL,PRPROP_WRITE,NULL);
 if(scalemode)  osxprintpropscale(oldscale,NULL,PRPROP_WRITE,NULL);

 return(err);
}





os_error * osxprint(wimp_w handle,uservalue userhandle,void * data,osprintfn printfn,osabortprintfn abortfn,int flags)
{
 os_error       * err;
 HDC              hdc;
 HANDLE           hPrinter;
 DWORD            needed;
 PRINTER_INFO_2 * prinfo;


 err=NULL;


 xabort=abortfn;
 xuserhandle=userhandle;
 xhandle=handle;
 xdata=data;
 xflags=flags;

 cprintf("starting print flags %x",xflags);

	if(*printername)
	{
//  Use this code to pass pdevemode pass values for StartDocPrinter()
//		PRINTER_DEFAULTS defaults;
//		defaults.DesiredAccess=PRINTER_ACCESS_USE;
//		defaults.pDatatype="RAW";
//		defaults.pDevMode=pdevmode;
//  err=XOpenPrinter(printername,&hPrinter,&defaults);

  err=XOpenPrinter(printername,&hPrinter,NULL);
		if(!err)
		{
   xprinter=hPrinter;

   if(flags & PRXRAW)
   {
    wimp_redrawstr r;
  		int            left;
  		int            right;
  		int            top;
  		int            bottom;
  		int            width;
    int            height;

#ifdef _DEBUG
    err=XGetPrinterDriver(hPrinter,NULL,2,NULL,0,&needed);
				if(!err)
				{
     PDRIVER_INFO_2 pdinfo;

     pdinfo=(PDRIVER_INFO_2)malloc(needed);
     err=XGetPrinterDriver(hPrinter,NULL,2,(LPBYTE)pdinfo,needed,&needed);
					if(!err)
					{
      cprintf("pdriver %s",pdinfo->pDataFile);

      free(pdinfo);
					}
				}
#endif

    memset(&r,0,sizeof(r));

    err=osxgetmarginsreal(&left,&right,&top,&bottom,&width,&height,180,180,hPrinter);
				if(!err)
				{
     r.box.x0=0;
     r.box.x1=width;
     r.box.y1=0;
     r.box.y0=-height;

     r.scx=0;
     r.scy=0;

     r.g.x0=left;
   		r.g.x1=right;
   		r.g.y1=-top;
   		r.g.y0=-bottom;


  		cprintf("x0 %d x1 %d y0 %d y1 %d",r.box.x0,r.box.x1,r.box.y0,r.box.y1);
  		cprintf("x0 %d x1 %d y0 %d y1 %d",r.g.x0,r.g.x1,r.g.y0,r.g.y1);

     err=printfn(&r,0,xdata,xuserhandle);
				}
   }
   else
   if(xflags & PRXRAW2)
   {
    wimp_redrawstr r;
  		int            left;
  		int            right;
  		int            top;
  		int            bottom;
  		int            width;
    int            height;
    int            iEsc;

    err=XGetPrinter(hPrinter,2,NULL,0,&needed);
				if(!err)
				{
     prinfo=(PRINTER_INFO_2*)malloc(needed);
     err=XGetPrinter(hPrinter,2,(LPBYTE)prinfo,needed,&needed);

					if(!err)
					{
      err=XCreateDC(prinfo->pDriverName, // driver name
                    prinfo->pPrinterName, // device name
                    prinfo->pPortName,    // port or file name
                    pdevmode,             // optional initialization data
		 																	&hdc
                   );


      iEsc=EPSPRINTING;
      if(ExtEscape(hdc,QUERYESCSUPPORT,sizeof(int),(LPSTR)&iEsc,0,NULL))
      {
       iEsc=1;
       iEsc=ExtEscape(hdc,EPSPRINTING,sizeof(int),(LPSTR)&iEsc,0,NULL);
      }
      else
      {
       err=generror(0,"Can't use direct PS because EPS escape not supported");
      }

      if(!err)
      {
       xprinthdc=hdc;

       memset(&r,0,sizeof(r));

       err=osxgetmarginsreal(&left,&right,&top,&bottom,&width,&height,180,180,hPrinter);
  	 			if(!err)
       {
        r.box.x0=0;
        r.box.x1=width;
        r.box.y1=0;
        r.box.y0=-height;
    
        r.scx=0;
        r.scy=0;

        r.g.x0=left;
      		r.g.x1=right;
      		r.g.y1=-top;
      		r.g.y0=-bottom;
     
      
        err=printfn(&r,0,xdata,xuserhandle);
       }

       err=XDeleteDC(hdc,err);
						}
     }
    }
   }
   else
   {
    err=XGetPrinter(hPrinter,2,NULL,0,&needed);
				if(!err)
				{
     prinfo=(PRINTER_INFO_2*)malloc(needed);
     err=XGetPrinter(hPrinter,2,(LPBYTE)prinfo,needed,&needed);
//				cprintf("print2 %x",err);

					if(!err)
					{
      err=XCreateDC(prinfo->pDriverName, // driver name
                   prinfo->pPrinterName, // device name
                   prinfo->pPortName,    // port or file name
                   pdevmode,             // optional initialization data
																			&hdc
                  );


						if(!err)
						{
       err=osprintdc(hdc,printfn,abortfn);  // interersting error from printfn

       err=XDeleteDC(hdc,err);
						}
					}
     free(prinfo);
				}
   }

   err=XClosePrinter(hPrinter,err);
		}
	}
	else
	{
		err=geterror(ENOPRINTER);
	}

 return(err);
}





os_error * osxprintmargins(int * left,int * right,int * top,int * bottom,int * width,int * height,int xres,int yres)
{
	os_error       * err;
 HANDLE           hPrinter;
 DWORD            needed;
 PRINTER_INFO_2 * prinfo;

	err=NULL;

	if(*printername)
	{
  err=XOpenPrinter(printername,&hPrinter,NULL);
		if(!err)
		{
   err=XGetPrinter(hPrinter,2,NULL,0,&needed);
			if(!err)
			{
    prinfo=(PRINTER_INFO_2*)malloc(needed);
    if(prinfo)
    {
     err=osxgetmarginsreal(left,right,top,bottom,width,height,xres,yres,hPrinter);
    }
			}
   err=XClosePrinter(hPrinter,err);
		}
	}
	else
	{
		err=geterror(ENOPRINTER);
	}

 return(err);
}



os_error * osxactiveprintmargins(int * left,int * right,int * top,int * bottom,int * width,int * height,int xres,int yres)
{
	os_error       * err;
 HANDLE           hPrinter;
 DWORD            needed;
 PRINTER_INFO_2 * prinfo;

	err=NULL;

	if(*printername)
	{
  err=XOpenPrinter(printername,&hPrinter,NULL);
		if(!err)
		{
   err=XGetPrinter(hPrinter,2,NULL,0,&needed);
			if(!err)
			{
    prinfo=(PRINTER_INFO_2*)malloc(needed);
    if(prinfo)
    {
     err=osxgetmargins(left,right,top,bottom,width,height,xres,yres,hPrinter);
    }
			}
   err=XClosePrinter(hPrinter,err);
		}
	}
	else
	{
		err=geterror(ENOPRINTER);
	}

 return(err);
}





os_error * osxprinterdata(char * dataname,int maxsize)
{
 os_error       * err;
 HANDLE           hPrinter;
 DWORD            needed;
 PDRIVER_INFO_2   pdinfo;


	if(*printername)
	{
  err=XOpenPrinter(printername,&hPrinter,NULL);
		if(!err)
		{
   err=XGetPrinterDriver(hPrinter,NULL,2,NULL,0,&needed);
			if(!err)
			{
    pdinfo=(PDRIVER_INFO_2)malloc(needed);
    err=XGetPrinterDriver(hPrinter,NULL,2,(LPBYTE)pdinfo,needed,&needed);
				if(!err)
				{
     cprintf("pdriver %s",pdinfo->pDataFile);
     err=xzstrncpye(dataname,pdinfo->pDataFile,maxsize);

     free(pdinfo);
				}
   }
   err=XClosePrinter(hPrinter,err);
  }
 }
	else
	{
		err=geterror(ENOPRINTER);
	}


 return(err);
}









static TCHAR * fontsubtable;
static int     fontsubtablesize;



os_error * osxprintcachefontsubs(void)
{
 os_error       * err;
 PRINTER_INFO_2 * prinfo;
 DWORD            needed;
 HANDLE           hPrinter;

	cprintf("osxprintcachefontsubs");


 err=NULL;

 if(fontsubtable) err=sfree((flex_ptr)&fontsubtable);
 fontsubtablesize=0;

	if(*printername)
	{

			cprintf("osxprintcachefontsubs1");

  err=XOpenPrinter(printername,&hPrinter,NULL);
  if(!err)
  {
				cprintf("osxprintcachefontsubs 2");
   err=XGetPrinter(hPrinter,2,NULL,0,&needed);
   if(!err)
   {
					cprintf("osxprintcachefontsubs 3");
    prinfo=(PRINTER_INFO_2*)malloc(needed);
    if(prinfo)
    {
						cprintf("osxprintcachefontsubs 4");
     err=XGetPrinter(hPrinter,2,(LPBYTE)prinfo,needed,&needed);
     if(!err)
     {
							cprintf("osxprintcachefontsubs 5");
      err=XGetPrinterData(hPrinter,TEXT("TTFontSubTable"),NULL,NULL,0,(unsigned long*)&needed);
						if(err) cprintf("errro %s",err->errmess);
      if(!err) err=salloc((flex_ptr)&fontsubtable,needed);
      if(!err)
      {
								cprintf("osxprintcachefontsubs 6");
       err=XGetPrinterData(hPrinter,TEXT("TTFontSubTable"),NULL,(unsigned char*)fontsubtable,needed,(unsigned long*)&fontsubtablesize);
      }
     }
     free(prinfo);
    }
   }
   err=XClosePrinter(hPrinter,err);
  }
 }

	cprintf("fontsubtablesize %d",fontsubtablesize);

 return(err);
}




// look up windows font family name, return printer font name in PS format

os_error * osxprintmapfont(TCHAR * windows,TCHAR ** printer)
{
 TCHAR * p;
 TCHAR * lt;

 *printer=NULL;

 if(fontsubtable)
 {
  p=fontsubtable;
  lt=fontsubtable+fontsubtablesize;
  while(p<lt)
  {
   if(!cstrcmp(p,windows))
   {
//   cprintf("print font %s %s",p,p+(strlen(p)+1));
    *printer=p+(ustrlen(p)+1);
    break;
   }

   p+=strlen(p)+1;
   if(*p==0) break;
   p+=strlen(p)+1;
  }
 }

 return(NULL);
}





#ifdef NEVER



// no luck at getting family member names for device fonts
// just get 4 off family name



static os_error * osxfn(char * facename,char * fullfontname,font_enumdata * data)
{

 cprintf("enum %s full %s",facename,fullfontname);

 return(NULL);
}







static char * fontsubtable;
static int    fontsubtablesize;

os_error * osxprintcachefontsubs(void)
{
 os_error * err;
 char       path[MAX_PATH];

 err=NULL;


// HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\Print\Printers\Generic PostScript Printer\PrinterDriverData


	if(*printername)
	{
  if(fontsubtable) sfree((flex_ptr)&fontsubtable);

  sprintf(path,"HKLM\\SYSTEM\\CurrentControlSet\\Control\\Print\\Printers\\%s\\PrinterDriverData\\TTFontSubTable",printername);

  err=regallocstr(path,&fontsubtable,&fontsubtablesize);

  cprintf("fontsubtable %d",fontsubtablesize);
 }

 {
  font_description fd;

  strcpy(fd.name,"");
  fd.charset=ANSI_CHARSET;


  osxfont_enumerate(&fd,osxfn);
 }

 return(err);
}






os_error * osxfont_enumerate(font_description * fd,fontenumfn fn)
{
	os_error       * err;
 PRINTER_INFO_2 * prinfo;
 HDC              hdc;
 DWORD            needed;
 HANDLE           hPrinter;
 hdcstr         * hdcptr; 

	err=NULL;

 OpenPrinter(printername,&hPrinter,NULL);

 GetPrinter(hPrinter,2,NULL,0,&needed);
 prinfo=(PRINTER_INFO_2*)malloc(needed);
 GetPrinter(hPrinter,2,(LPBYTE)prinfo,needed,&needed);


 hdc=CreateIC(prinfo->pDriverName, // driver name
               prinfo->pPrinterName,// device name
               prinfo->pPortName,   // port or file name
               pdevmode             // optional initialization data
              );
  
 if(hdc)
 {
   err=graphicsnewhdc(&hdcptr);
   hdcptr->hdc=hdc;
   err=graphicssetcurrent(hdcptr);


		font_enumerate(fd,fn);


	char buffer[256];

 GetPrinterData(hPrinter,    // handle to printer or print server
                "TTFontSubTable",  // value name
                NULL,      // data type
                (unsigned char*)buffer,       // configuration data buffer
                sizeof(buffer)/sizeof(TCHAR),        // size of configuration data buffer
                &needed   // bytes received or required 
               );

		cprintf("buffer %s %s",buffer,buffer+strlen(buffer)+1);

  DeleteDC(hdcptr->hdc);
		graphicsdeletehdc(hdcptr);
 }

 free(prinfo);

	return(err);
}










  int    iEsc = EPSPRINTING;
     if (Escape(hdc, QUERYESCSUPPORT, sizeof(int), (LPSTR)&iEsc, NULL))
       {
       iEsc = 1;  // 1 == enable PASSTHROUGH (disable pscript header)
       Escape(hdc, EPSPRINTING, sizeof(int), (LPSTR)&iEsc, NULL);
       }



       BOOL RawDataToPrinter(LPSTR szPrinterName, LPBYTE lpData, DWORD dwCount)
      {
        HANDLE     hPrinter;
        DOC_INFO_1 DocInfo;
        DWORD      dwJob;
        DWORD      dwBytesWritten;

        // Need a handle to the printer.
        if( ! OpenPrinter( szPrinterName, &hPrinter, NULL ) )
          return FALSE;


        // Fill in the structure with info about this "document."
        DocInfo.pDocName =TEXT("My Document");
        DocInfo.pOutputFile = NULL;
        DocInfo.pDatatype =TEXT("RAW");
        // Inform the spooler the document is beginning.
        if( (dwJob = StartDocPrinter( hPrinter, 1, (unsigned char *)&DocInfo )) == 0 )
        {
          ClosePrinter( hPrinter );
          return FALSE;
        }
        // Start a page.
        if( ! StartPagePrinter( hPrinter ) )
        {
          EndDocPrinter( hPrinter );
          ClosePrinter( hPrinter );
          return FALSE;
        }
        // Send the data to the printer.
        if( !WritePrinter( hPrinter, lpData, dwCount, &dwBytesWritten ) )
        {
          EndPagePrinter( hPrinter );
          EndDocPrinter( hPrinter );
          ClosePrinter( hPrinter );
          return FALSE;
        }
        // End the page.
        if( ! EndPagePrinter( hPrinter ) )
        {
          EndDocPrinter( hPrinter );
          ClosePrinter( hPrinter );
          return FALSE;
        }
        // Inform the spooler that the document is ending.
        if( ! EndDocPrinter( hPrinter ) )
        {
          ClosePrinter( hPrinter );
          return FALSE;
        }
        // Tidy up the printer handle.
        ClosePrinter( hPrinter );
        // Check to see if correct number of bytes were written.
        if( dwBytesWritten != dwCount )
          return FALSE;
        return TRUE;
      }




void osprinttest(void)
{

 RawDataToPrinter(printername,(unsigned char*)"xxxxx",5);

}



os_error * osxprintcachefontsubs(void)
{
 os_error       * err;
 PRINTER_INFO_2 * prinfo;
 HDC              hdc;
 DWORD            needed;
 HANDLE           hPrinter;
 hdcstr         * hdcptr; 
 char           * fontsubtable;
 font_description fd;
 char           * p;
 char           * lt;



 err=NULL;

	if(*printername)
	{
  OpenPrinter(printername,&hPrinter,NULL);

  GetPrinter(hPrinter,2,NULL,0,&needed);
  prinfo=(PRINTER_INFO_2*)malloc(needed);
  if(prinfo)
  {
   GetPrinter(hPrinter,2,(LPBYTE)prinfo,needed,&needed);

   GetPrinterData(hPrinter,TEXT("TTFontSubTable"),NULL,NULL,0,&needed);
   fontsubtable=(char*)malloc(needed);
   if(fontsubtable)
   {
    GetPrinterData(hPrinter,TEXT("TTFontSubTable"),NULL,(unsigned char*)fontsubtable,needed,&needed);

    hdc=CreateIC(prinfo->pDriverName,prinfo->pPrinterName,prinfo->pPortName,pdevmode);
  
    if(hdc)
    {
     err=graphicsnewhdc(&hdcptr);
     hdcptr->hdc=hdc;
     err=graphicssetcurrent(hdcptr);

     cprintf("subtable size %d",needed);

     p=fontsubtable;
     lt=fontsubtable+needed;
     while(p<lt)
     {
      cprintf("print font %s",p);

//      xzstrncpy(fd.name,p,sizeof(fd.name));
//      fd.charset=ANSI_CHARSET;
//      font_enumerate(&fd,osxfn);

      p+=strlen(p)+1;
      if(*p==0) break;

      xzstrncpy(fd.name,p,sizeof(fd.name)/sizeof(TCHAR));
      fd.charset=DEFAULT_CHARSET;
      font_enumerate(&fd,osxfn);


      p+=strlen(p)+1;
     }


     DeleteDC(hdcptr->hdc);
 		  graphicsdeletehdc(hdcptr);
    }
    free(fontsubtable);
   }
   free(prinfo);
  }

  ClosePrinter(hPrinter);
 }

 return(err);
}





#endif






//NT4
//==== ESC ====
//==== PS PASS ====
//==== OPEN CHANNEL ====
//==== DOWNLOAD ====

// XP
//==== ESC ====
//==== PS ID ====
//==== PS PASS ====
//==== OPEN CHANNEL ====
//==== DOWNLOAD ====


#ifdef _DEBUG

static void testescapes(HDC hdc)
{

     int    iEsc = QUERYESCSUPPORT;
     if (Escape(hdc, QUERYESCSUPPORT, sizeof(int), (LPSTR)&iEsc, NULL))
     {
        cprintf("==== ESC ====");

//       iEsc = 1;  // 1 == enable PASSTHROUGH (disable pscript header)
//       Escape(hdc, EPSPRINTING, sizeof(int), (LPSTR)&iEsc, NULL);
     }

     iEsc=EPSPRINTING;
     if(Escape(hdc,QUERYESCSUPPORT,sizeof(int),(LPSTR)&iEsc,NULL))
     {
       cprintf("==== EPS ====");
     }


     iEsc=ENCAPSULATED_POSTSCRIPT;
     if(Escape(hdc,QUERYESCSUPPORT,sizeof(int),(LPSTR)&iEsc,NULL))
     {
       cprintf("==== ENCAP ====");
     }


     iEsc=POSTSCRIPT_IDENTIFY;
     if(Escape(hdc,QUERYESCSUPPORT,sizeof(int),(LPSTR)&iEsc,NULL))
     {
       cprintf("==== PS ID ====");
     }


     iEsc=POSTSCRIPT_INJECTION ;
     if(Escape(hdc,QUERYESCSUPPORT,sizeof(int),(LPSTR)&iEsc,NULL))
     {
       cprintf("==== PS IJ ====");
     }


     iEsc=POSTSCRIPT_PASSTHROUGH ;
     if(Escape(hdc,QUERYESCSUPPORT,sizeof(int),(LPSTR)&iEsc,NULL))
     {
       cprintf("==== PS PASS ====");
     }


     iEsc=OPENCHANNEL ;
     if(Escape(hdc,QUERYESCSUPPORT,sizeof(int),(LPSTR)&iEsc,NULL))
     {
       cprintf("==== OPEN CHANNEL ====");
     }

     iEsc=DOWNLOADHEADER ;
     if(Escape(hdc,QUERYESCSUPPORT,sizeof(int),(LPSTR)&iEsc,NULL))
     {
       cprintf("==== DOWNLOAD ====");

     }



     iEsc = QUERYESCSUPPORT;
     if (ExtEscape(hdc, QUERYESCSUPPORT, sizeof(int), (LPSTR)&iEsc, 0, NULL))
     {
        cprintf("==== XESC ====");

//       iEsc = 1;  // 1 == enable PASSTHROUGH (disable pscript header)
//       Escape(hdc, EPSPRINTING, sizeof(int), (LPSTR)&iEsc, NULL);
     }

     iEsc=EPSPRINTING;
     if(ExtEscape(hdc,QUERYESCSUPPORT,sizeof(int),(LPSTR)&iEsc,0,NULL))
     {
       cprintf("==== XEPS ====");
     }


     iEsc=ENCAPSULATED_POSTSCRIPT;
     if(ExtEscape(hdc,QUERYESCSUPPORT,sizeof(int),(LPSTR)&iEsc,0,NULL))
     {
       cprintf("==== XENCAP ====");
     }


     iEsc=POSTSCRIPT_IDENTIFY;
     if(ExtEscape(hdc,QUERYESCSUPPORT,sizeof(int),(LPSTR)&iEsc,0,NULL))
     {
       cprintf("==== XPS ID ====");
     }


     iEsc=POSTSCRIPT_INJECTION ;
     if(ExtEscape(hdc,QUERYESCSUPPORT,sizeof(int),(LPSTR)&iEsc,0,NULL))
     {
       cprintf("==== XPS IJ ====");
     }


     iEsc=POSTSCRIPT_PASSTHROUGH ;
     if(ExtEscape(hdc,QUERYESCSUPPORT,sizeof(int),(LPSTR)&iEsc,0,NULL))
     {
       cprintf("==== XPS PASS ====");
     }


     iEsc=OPENCHANNEL ;
     if(ExtEscape(hdc,QUERYESCSUPPORT,sizeof(int),(LPSTR)&iEsc,0,NULL))
     {
       cprintf("==== XOPEN CHANNEL ====");
     }

     iEsc=DOWNLOADHEADER ;
     if(ExtEscape(hdc,QUERYESCSUPPORT,sizeof(int),(LPSTR)&iEsc,0,NULL))
     {
       cprintf("==== XDOWNLOAD ====");

     }
}


#endif