

#include <stdafx.h>

#include "os.h"
#include "wimp.h"
#include "transform.h"

#include "xmath.h"


#include "deb.h"
#include "colour.h"
#include "osgraphics.h"
#include "akbd.h"
#include "key.h"

#include "osunits.h"




int xcoordos2pix(int osunits)
{
 return(scale(osunits,cvdu.xdpi,OSXRES));
}


int xcoordpix2os(int pix)
{
 return(scale(pix,OSXRES,cvdu.xdpi));
}


int ycoordos2pix(int osunits)
{
 return(cvdu.ypix-scale(osunits,cvdu.ydpi,OSYRES));
}


int ycoordpix2os(int pix)
{
 return(scale(cvdu.ypix-pix,OSYRES,cvdu.ydpi));
}


int xos2pix(int osunits)
{
 return(scale(osunits,cvdu.xdpi,OSXRES));
}


int xpix2os(int pix)
{
 return(scale(pix,OSXRES,cvdu.xdpi));
}


int yos2pix(int osunits)
{
 return(scale(osunits,cvdu.ydpi,OSYRES));
}


int ypix2os(int pix)
{
 return(scale(pix,OSYRES,cvdu.ydpi));
}




// the above are really only of use for window positioning
// to get from pixels to os units you would have to reproduce
// the transforms set up in osgraphics


void grpix2os(int * x,int * y)
{

#ifdef NEVER
 POINT pt;

 pt.x=*x;
 pt.y=*y;

 DPtoLP(currenthdcptr->hdc,&pt,1);

 *x=pt.x;
 *y=pt.y;

#endif

	*x=GRINVXPIX(*x);
	*y=GRINVYPIX(*y);
}


// this is reversible, guaranteed that x,y in os units will convert
// back to the same pixel values
// won't work if pix res is higher than os units e.g. printer

void grpix2osr(int * x,int * y)
{
 int ox,oy,xt,yt;
 
 ox=*x;
 oy=*y;

 grpix2os(x,y);

 while(1)
 {
  xt=*x;
  yt=*y;

  gros2pix(&xt,&yt);

  if(xt==ox && yt==oy) break;

  if(xt>ox) *x=(*x)-1;
  if(xt<ox) *x=(*x)+1;
  if(yt>oy) *y=(*y)+1;
  if(yt<oy) *y=(*y)-1;

//  cprintf("yt %d oy %d",yt,oy);
//  while(isshift);
 }
}



void gros2pix(int * x,int * y)
{
#ifdef NEVER

 POINT pt;

 pt.x=*x;
 pt.y=*y;

 LPtoDP(currenthdcptr->hdc,&pt,1);

 *x=pt.x;
 *y=pt.y;
#endif

	*x=GRXPIX(*x);
	*y=GRYPIX(*y);

}


