/*->c.sp */

#include <stdafx.h>


#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>


#include "os.h"


#include "flex.h"
#include "alloc.h"
#include "sprite.h"
#include "wimpt.h"
#include "wimp.h"


#include "fsx.h"
#include "bf.h"
#include "wos.h"
#include "colour.h"
#include "task.h"
#include "oserr.h"
#include "osglue.h"
#include "deb.h"
#include "applet.h"


#include "sp.h"


#define SPSIZE 0x100


char * sprites;



/* merge in a new template file */

static os_error * addspritess(char * path,char * leaf,sprite_area ** sprites,HINSTANCE instance)
{
 os_error  *   err;
 char          name[MAX_PATH];
 fstat         f;
 unsigned int  free;
 int           newsize;
 sprite_area * area;
 unsigned int  length=0;
 HANDLE        hDialog=NULL; 
 HRSRC         hRsrc;
 char        * q=NULL;


// cprintf("addspritess fn %s %s",path,leaf);




 if(path)
 {
  strcpy(name,path);
  strcat(name,"\\");
  strcat(name,leaf);

  err=fs_stat(name,&f);

//  cprintf("stat %s %d",name,f.object);


  if(!err && f.object)
  {
   area=*sprites;

   free=area->size-area->freeoff;
   if((unsigned int)f.length>free)
   {
    newsize=area->freeoff+f.length+SPSIZE;
    err=flex_extend((flex_ptr)sprites,newsize);
    if(!err) (*sprites)->size=newsize;
   }

   if(!err) err=sprite_area_merge(*sprites,name);
  }
 }
 else
 {
  err=XFindResource(instance,leaf,"Sprites",&hRsrc);
  if(err)
  {
   err=NULL;   // might be no sprites
  }
  else
  {
            err=XLoadResource(instance,hRsrc,(HGLOBAL*)&hDialog);
   if(!err) err=XLockResource(hDialog,(LPVOID*)&q);
   if(!err) err=XSizeofResource(instance,hRsrc,&length);
   if(!err)
   {
//    cprintf("sprites load");

    area=*sprites;

    free=area->size-area->freeoff;

    if(length>free)
    {
     newsize=area->freeoff+length+SPSIZE;

     err=flex_extend((flex_ptr)sprites,newsize);
     if(!err) (*sprites)->size=newsize;
    }

    if(!err) err=sprite_area_merge_memory(*sprites,q);
   }
  }
 }

 return(err);
}



// header in applet.h

os_error * addspritesxs2(char * path,char * leaf,sprite_area ** sprites,ascaninstance instance)
{
 os_error * err;
 char       temp[128];

 if(path)
 {
  strcpy(temp,leaf);
  fs_addtoname(temp,"22");

  if((cvdu.deltax<=2 && cvdu.deltay<=2 && resexists(path,temp)) ||
                                        !resexists(path,leaf))
  {
   err=addspritess(path,temp,sprites,(HINSTANCE)instance);
  }
  else
  {
   err=addspritess(path,leaf,sprites,(HINSTANCE)instance);
  }
 }
 else
 {
  err=addspritess(path,leaf,sprites,(HINSTANCE)instance);
 }



 return(err);
}


os_error * addspritesxs(char * path,char * leaf,sprite_area ** sprites)
{
 return(addspritesxs2(path,leaf,sprites,(ascaninstance)AppInstance));
}





os_error * addspritesx(char * path,char * leaf)
{
 return(addspritesxs2(path,leaf,(sprite_area**)&sprites,(ascaninstance)AppInstance));
}



os_error * initspritess(sprite_area ** sprites)
{
 os_error * err;

 err=flex_alloc((flex_ptr)sprites,SPSIZE);
 if(!err)
 {
  sprite_area_initialise(*sprites,SPSIZE);
 }

 return(err); 
}



os_error * initsprites(void)
{
 return(initspritess((sprite_area**)&sprites));
}


#ifdef NEVER


// don't like memory area mixing in this

os_error * loadspritearea(char * path,char * leaf,sprite_area ** areap,
                                                                 int flex)
{
 os_error  *   err;
 fstat         f;
 sprite_area * area;
 char          name[MAX_PATH];

 strcpy(name,path);
 strcat(name,"\\");
 strcat(name,leaf);

 err=fs_stat(name,&f);
 if(!err && f.object)
 {
  if(flex) err=flex_alloc((flex_ptr)areap,f.length+SPSIZE);
  else     err=salloc((flex_ptr)areap,f.length+SPSIZE);
  if(!err)
  {
   area=*areap;
   sprite_area_initialise(area,f.length+SPSIZE);
   err=sprite_area_merge(area,name);
  }
 }
 return(err);
}


#endif



int * spfind(sprite_area * areap,char * name)
{
 return((int*)sprite_find(areap,name));
}





os_error * spsave(sprite_header * sph,char * name)
{
 os_error * err;
 buffer     bf;

 err=bf_open(name,'w',DEFBUFFSIZE,&bf);
 if(!err)
 {
  bf_puti(&bf,1);  /* no sprites */
  bf_puti(&bf,16);  /* first offset */
  bf_puti(&bf,sizeof(sprite_header)+sph->next+16); /* next sprite */
  bf_write(&bf,sph,sizeof(sprite_header)+sph->next);

  err=bf_closec(&bf,err,name,0xFF9);
 }

 return(err);
}





