/*->c.wos */


#include <stdafx.h>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <ctype.h>
#include <time.h>
#include <stdarg.h>

#include "os.h"
#include "wimp.h"
#include "werr.h"
#include "wimpt.h"
#include "transform.h"
#include "xprocess.h"

#include "osglue.h"
#include "osgraphics.h"
#include "ossprite.h"

#include "osunits.h"
#include "err.h"
#include "trans.h"
#include "bits.h"
#include "etc.h"

#include "oserr.h"
#include "deb.h"
#include "xmath.h"
#include "colour.h"

#include "wos.h"

#include "poll.h"




os_error * select(wimp_w handle,int icon)
{
 LRESULT result;

 return(XSendDlgItemMessage((HWND)handle,icon,BM_SETCHECK,BST_CHECKED,0,&result));
}


os_error * deselect(wimp_w handle,int icon)
{
 LRESULT result;

 return(XSendDlgItemMessage((HWND)handle,icon,BM_SETCHECK,BST_UNCHECKED,0,&result));
}


os_error * selectst(wimp_w handle,int icon,int state)
{
 LRESULT result;

 return(XSendDlgItemMessage((HWND)handle,icon,BM_SETCHECK,state?BST_CHECKED:BST_UNCHECKED,0,&result));
}



os_error * enablewindow(wimp_w window,int state,int recurse)
{

 EnableWindow((HWND)window,state);

 return(NULL);

 USE(recurse);
}



os_error * shadeicon(wimp_w window,int icon)
{
 os_error * err;
 HWND       child;

 err=XGetDlgItem((HWND)window,icon,&child);
 if(!err) EnableWindow(child,FALSE);

 return(err);
}


os_error * unshadeicon(wimp_w window,int icon)
{
 os_error * err;
 HWND       child;

 err=XGetDlgItem((HWND)window,icon,&child);
 if(!err) EnableWindow(child,TRUE);

 return(err);
}




os_error * shadeiconst(wimp_w window,int icon,int state)
{
 if(state) return(shadeicon(window,icon));
 else      return(unshadeicon(window,icon));
}


os_error * writeableicon(wimp_w window,int icon)
{
 return(NULL);
 USE(window);
 USE(icon);
}

os_error * unwriteableicon(wimp_w window,int icon)
{
 return(NULL);
 USE(window);
 USE(icon);
}


os_error * writeableiconst(wimp_w window,int icon,int state)
{
 if(state) return(writeableicon(window,icon));
 else      return(unwriteableicon(window,icon));
}



static char * cursormap[]=
{
 //IDC_HAND,         // Windows 2000: Hand 
 IDC_ARROW,        // Standard arrow               SYSTEMPOINTER
 NULL,             //                              USERPOINTER
 IDC_APPSTARTING,  // Standard arrow and small hourglass 
 IDC_CROSS,        // Crosshair 
 IDC_HELP,         // Arrow and question mark 
 IDC_IBEAM,        // I-beam 
 IDC_ICON,         // Obsolete for applications marked version 4.0 or later. 
 IDC_NO,           // Slashed circle 
 IDC_SIZE,         // Obsolete for applications marked version 4.0 or later. Use IDC_SIZEALL. 
 IDC_SIZEALL,      // Four-pointed arrow pointing north, south, east, and west 
 IDC_SIZENESW,     // Double-pointed arrow pointing northeast and southwest 
 IDC_SIZENS,       // Double-pointed arrow pointing north and south 
 IDC_SIZENWSE,     // Double-pointed arrow pointing northwest and southeast 
 IDC_SIZEWE,       // Double-pointed arrow pointing west and east 
 IDC_UPARROW,      // Vertical arrow 
 IDC_WAIT,         // Hourglass

};



os_error * changepointer(int type,pointstr * pointdata,TCHAR * sprites)
{
 HCURSOR hcursor;

 if(type==BADPOINTER)
 {


 }
 else
 if(type==ICONPOINTER)
 {
  if(pointdata==NULL) hcursor=LoadCursor(AppInstance,sprites);
  else                hcursor=LoadCursor(AppInstance,pointdata->name);
//  hcursor=(HCURSOR)LoadImage(AppInstance,sprites,IMAGE_CURSOR,0,0,LR_DEFAULTSIZE);
  SetCursor(hcursor);
 }
 else
 if(type==NOPOINTER)
 {
  SetCursor(NULL);
 }
 else
 if(type==USERPOINTER)
 {
  hcursor=LoadCursor(sprites==NULL?AppInstance:(HINSTANCE)sprites,pointdata->name);
  SetCursor(hcursor);
 }
 else
 {
  hcursor=LoadCursor(NULL,cursormap[type]);
  SetCursor(hcursor);
 }

 return(NULL);
}



/*

// change left to right hand

int fixbuttons(int bbits)
{
 int           m1;
 int           m2;

 m1=(bbits>>2) & 0x111;
 m2=(bbits<<2) & 0x444;

 bbits=(bbits & 0x222)|m2|m1;

 return(bbits);
}
*/




os_error * getpointer(mousestr * mouse)
{
 os_error * err;
 POINT      pt;
 HWND       hwnd;
 HWND       child;
 HWND       parent;
 int        task;

 err=XGetCursorPos(&pt);
 if(!err)
 {
  mouse->x=xcoordpix2os(pt.x);
  mouse->y=ycoordpix2os(pt.y);
  hwnd=WindowFromPoint(pt);

  mouse->handle=(hwnd!=NULL)?(wimp_w)hwnd:(wimp_w)(-1);
  mouse->icon=-1;

  if(GetKeyState(VK_LBUTTON) & 0x8000) mouse->buttons=0x4;
  else
  if(GetKeyState(VK_RBUTTON) & 0x8000) mouse->buttons=0x1;
  else                               mouse->buttons=0x0;

  if(mouse->handle!=NULL)
  {
   findwindowtask(mouse->handle,-1,&task);

   if(task==taskhandle)  // we at least know this window is ours
   {
    // possibly hwnd is a control in a window?

    parent=getcontrolparentwindow(hwnd);
    if(parent) mouse->handle=(wimp_w)parent;

    XScreenToClient(hwnd,&pt);
  
    while(1)
    {
     child=ChildWindowFromPoint(hwnd,pt);
     if(child && child!=hwnd)
     {
      hwnd=child;
     }
     else
     {
      break;
     }
    }

    if(hwnd!=parent)
    {
     err=XGetDlgCtrlID(hwnd,&mouse->icon);
    }
   }
  }
 }

 return(err);
}





os_error * wimp_get_point_info(wimp_mousestr * result)
{
 os_error * err;
 mousestr   mouse;

 err=getpointer(&mouse);
 if(!err)
 {
  result->bbits=(wimp_bbits)mouse.buttons;
  result->i=mouse.icon;
  result->w=mouse.handle;
  result->x=mouse.x;
  result->y=mouse.y;
 }

 return(err);
}






#ifdef NEVER

           ClientToScreen(hWnd, &pt);
           /*
            * Get the handle of the window at this point. If the window
            * is a control that is disabled, hidden, or transparent, then
            * the parent's handle is returned.
            */ 
           hWndPoint = WindowFromPoint(pt);

           if (hWndPoint == NULL)
               break;
           /*
            * To look at the child windows of hWnd, screen coordinates
            * need to be converted to client coordinates.
            */ 
           ScreenToClient (hWndPoint, &pt);

           /*
            * Search through all child windows at this point. This
            * will continue until no child windows remain.
            */ 
           while (TRUE)
               {
               hWndChild = ChildWindowFromPoint(hWndPoint, pt);

               if (hWndChild && hWndChild != hWndPoint)
                   hWndPoint = hWndChild;
               else
                   break;
               }

           // Do whatever processing is desired on hWndPoint


#endif




os_error * getospointer(mousestr * mouse)
{
 os_error * err;
 POINT      pt;
 HWND       hwnd;
// HWND       child;
// HWND       parent;
// int        task;

 err=XGetCursorPos(&pt);
 if(!err)
 {
  mouse->x=xcoordpix2os(pt.x);
  mouse->y=ycoordpix2os(pt.y);
  hwnd=WindowFromPoint(pt);

  mouse->handle=(hwnd!=NULL)?(wimp_w)hwnd:(wimp_w)(-1);
  mouse->icon=-1;

  if(GetKeyState(VK_LBUTTON) & 0x8000) mouse->buttons=0x4;
  else
  if(GetKeyState(VK_RBUTTON) & 0x8000) mouse->buttons=0x1;
  else                                 mouse->buttons=0x0;
	}

	return(err);
}




void getws(windowstr * window,wimp_openstr * o)
{
 window->x0=o->box.x0;
 window->y0=o->box.y0;
 window->x1=o->box.x1;
 window->y1=o->box.y1;
 window->scx=o->x;
 window->scy=o->y;
 window->bhandle=o->behind;
 window->bx=o->box.x0-o->x;
 window->by=o->box.y1-o->y;
}


void getos(windowstr * window,wimp_openstr * o)
{
 o->box.x0=window->x0;
 o->box.y0=window->y0;
 o->box.x1=window->x1;
 o->box.y1=window->y1;
 o->x=window->scx;
 o->y=window->scy;
 o->behind=window->bhandle;
 o->box.x0=window->bx+o->x;
 o->box.y1=window->by+o->y;
}




os_error * getw(wimp_w handle,windowstr * window)
{
 os_error *  err;
 wimp_wstate winds;

 err=wimp_get_wind_state(handle,&winds);
 getws(window,&winds.o);
 window->wflags=winds.flags;

 return(err);
}



os_error * geti(wimp_w handle,int icon,iconstr * icons)
{
 os_error * err;
 wimp_icon  istate;

 err=wimp_get_icon_info(handle,icon,&istate);
 icons->ix0=istate.box.x0;
 icons->iy0=istate.box.y0;
 icons->ix1=istate.box.x1;
 icons->iy1=istate.box.y1; 

 return(err);
}



os_error * open(wimp_w handle,int x0,int y0,int x1,int y1,int scx,int scy,
                                                               wimp_w behind)
{
 wimp_openstr oblock;

 oblock.w=handle;
 oblock.box.x0=x0;
 oblock.box.x1=x1;
 oblock.box.y0=y0;
 oblock.box.y1=y1;
 oblock.x=scx;
 oblock.y=scy;
 oblock.behind=behind;
 return(wimp_open_wind(&oblock));
}



/* offok flag controls if we are prepared for the window to be */
/* completely off screen */


int wonscreen(wimp_openstr * r)
{
 return(!(r->box.x0>=cvdu.screenx || r->box.x1<=0 || 
          r->box.y0>=cvdu.screeny || r->box.y1<=0));
}


os_error * wcheckopen(wimp_openstr * o,int offok)
{
 os_error     * err;
 wimp_openstr   r;

 r=*o;
 err=wimp_open_wind(o);
 if(!err)
 {
  if(r.box.x0<0 || r.box.x1>cvdu.screenx || 
     r.box.y0<0 || r.box.y1>cvdu.screeny)
  {
   if(offok || wonscreen(&r))
   {
    *o=r;
    err=wimp_open_wind(o);
   }
  }
 }
 return(err);
}



os_error * extent(wimp_w handle,int x0,int y0,int x1,int y1)
{
 wimp_redrawstr eblock;

 eblock.w=handle;
 eblock.box.x0=x0;
 eblock.box.y0=y0;
 eblock.box.x1=x1;
 eblock.box.y1=y1;

 return(wimp_set_extent(&eblock));
}



#define MAXICONLEN 1024


os_error * iconaddr(wimp_w handle,int icon,TCHAR ** p)
{ 
 os_error     * err;
 static TCHAR   buffer[MAXICONLEN];
 unsigned int   read;

//	cprintf("icon addr %d icon %d",handle,icon);

 err=XGetDlgItemText((HWND)handle,icon,buffer,sizeof(buffer)/sizeof(TCHAR),&read);

// cprintf("icon addr %s read %d",buffer,read);

 *p=buffer;
 return(err);
}


os_error * readicon(wimp_w handle,int icon,TCHAR * p,int size)
{
 unsigned int read;

//	cprintf("read handle %d icon %d p %x size %x",handle,icon,p,size);

 return(XGetDlgItemText((HWND)handle,icon,p,size,&read));
}



os_error * readiconunicode(wimp_w handle,int icon,wchar_t * dest,int size)
{
 unsigned int read;

//	cprintf("read handle %d icon %d p %x size %x",handle,icon,p,size);

 return(XGetDlgItemTextW((HWND)handle,icon,dest,size,&read));
}




os_error * caret(wimp_w handle,int icon,int x,int y,int height,int index)
{
 wimp_caretstr cblock;
 cblock.w=handle;
 cblock.i=icon;
 cblock.x=x;
 cblock.y=y;
 cblock.height=height;
 cblock.startindex=cblock.endindex=index;
 return(wimp_set_caret_pos(&cblock));
}



os_error * iecarrot(wimp_w wh,int ih)
{ 
 os_error * err;
 TCHAR    * p;

 err=iconaddr(wh,ih,&p);
 if(!err) err=caret(wh,ih,0,0,-1,ustrlen(p));

 return(err);
}



os_error * incarrot(wimp_w wh,int ih)
{
 os_error * err;
 TCHAR    * c;
 TCHAR    * p;

 err=iconaddr(wh,ih,&p);
 if(!err)
 {
  c=p;
  while(1)
  {
   if((*c<TEXT('0') || *c>TEXT('9')) && *c!=TEXT('.') && *c!=TEXT('/')) break;
   c++;
  }
  err=caret(wh,ih,0,0,-1,c-p);
 }

 return(err);
}




os_error * setfocus(wimp_w handle)
{
 HWND prev;
 return(XSetFocus((HWND)handle,&prev));
}


os_error * setfocusicon(wimp_w handle,int icon)
{
 os_error * err;
 HWND       prev;

          err=XGetDlgItem((HWND)handle,icon,&prev);
 if(!err) err=XSetFocus(prev,&prev);

 return(err);
}



os_error * setactive(wimp_w handle)
{

 SetActiveWindow((HWND)handle);
 return(NULL);
}


os_error * setforegroundwindow(wimp_w handle)
{

 SetForegroundWindow((HWND)handle);
 return(NULL);
}


os_error * minimisewindow(wimp_w handle)
{

 ShowWindow((HWND)handle,SW_MINIMIZE);
 return(NULL);
}



os_error * maximisewindow(wimp_w handle)
{

 ShowWindow((HWND)handle,SW_RESTORE);
 return(NULL);
}



os_error * applyshowcommand(wimp_w handle)
{

 ShowWindow((HWND)handle,AppCmdShow);
 return(NULL);
}



os_error * getactive(wimp_w * handle)
{

 *handle=(wimp_w)GetActiveWindow();

 return(NULL);
}



os_error * findcaret(wimp_w * chandle,int * cicon)
{ 
 os_error * err;
 wimp_caretstr cblock;

 err=wimp_get_caret_pos(&cblock);
 *chandle=cblock.w;
 *cicon=cblock.i;

 return(err);
}



/*
os_error * findnexttab(int handle,int icon,int previous,int * next)
{
 os_error * err;
 HWND       hwnd;

 err=XGetDlgItem((HWND)handle,icon,&hwnd);

 hwnd=GetNextDlgTabItem((HWND)handle,hwnd,(BOOL)previous);

 XGetDlgCtrlID(hwnd,next);

 return(err);
}
*/


os_error * findnexttabw(wimp_w parent,wimp_w child,int previous,int * next)
{
 os_error * err;
 HWND       hwnd;

 hwnd=GetNextDlgTabItem((HWND)parent,(HWND)child,(BOOL)previous);

 err=XGetDlgCtrlID(hwnd,next);

 return(err);
}




os_error * setnexttabw(wimp_w parent,wimp_w child,int previous)
{
 os_error * err;
 HWND       hwnd;

 err=NULL;

 hwnd=GetNextDlgTabItem((HWND)parent,(HWND)child,(BOOL)previous);

 XSetFocus(hwnd,&hwnd);

 return(err);
}



os_error * getparent(wimp_w handle,wimp_w * parent)
{
 return(XGetParent((HWND)handle,(HWND*)parent));
}







os_error * repainticon(wimp_w window,int icon)
{
 return(wimp_set_icon_state(window,icon,(wimp_iconflags)0,(wimp_iconflags)0));
}



os_error * iconlength(wimp_w window,int icon,int * len)
{
 *len=MAXICONLEN;
 return(NULL);
 USE(window);
 USE(icon);
}



os_error * writeicon(wimp_w window,int icon,TCHAR * string)
{
 SetDlgItemText((HWND)window,icon,string);
 return(NULL);
}


os_error * writeiconunicode(wimp_w window,int icon,wchar_t * string)
{
 SetDlgItemTextW((HWND)window,icon,string);
 return(NULL);
}




os_error * writeiconc(wimp_w window,int icon,TCHAR * string)
{
 os_error * err;
 TCHAR    * p;

 err=iconaddr(window,icon,&p);
 if(!err && strcmp(p,string)) err=writeicon(window,icon,string);

 return(err);
}




os_error * writeiconf(wimp_w window,int icon,TCHAR * format,...)
{
 os_error * err;
 va_list    args;
 TCHAR      v[MAXICONLEN];
 int        len;

 va_start(args, format);
 VSNPRINTF(v,sizeof(v)/sizeof(TCHAR),format,args,len);
 va_end(args);

 trans(v,sizeof(v));

// cprintf("trans %s",v);

 err=writeicon(window,icon,v);

 return(err);
}



/* only write the icon if something different */

os_error * writeiconfc(wimp_w window,int icon,TCHAR * format,...)
{
 os_error * err;
 va_list    args;
 TCHAR      v[MAXICONLEN];
 int        len;

 va_start(args, format);
 VSNPRINTF(v,sizeof(v)/sizeof(TCHAR),format,args,len);
 va_end(args);

 trans(v,sizeof(v)/sizeof(TCHAR));

 err=writeiconc(window,icon,v);

 return(err);
}



os_error * geticonint(wimp_w handle,int icon,int * val)
{
 os_error * err;
 int        code;
 TCHAR    * p;

 err=iconaddr(handle,icon,&p);
 if(!err)
 {
  code=sscanf(p,"%d",val);
  if(code!=1) err=geterror(EINT);
 }

 return(err);
}




os_error * geto(wimp_w handle,windowstr * window)
{
 os_error       * err;
 wimp_redrawstr   r;

 r.w=handle;

 err=wimp_getwindowoutline(&r);

 window->x0=r.box.x0;
 window->x1=r.box.x1;
 window->y0=r.box.y0;
 window->y1=r.box.y1;

 return(err);
}



os_error * setmouse(int x,int y)
{
 x=xcoordos2pix(x);
 y=ycoordos2pix(y);
 return(XSetCursorPos(x,y));
}





os_error * writetitle(wimp_w window,TCHAR * title)
{
 TCHAR v[MAXICONLEN];

 

 ustrcpy(v,title);

 trans(v,NITEM(v));

/*
#ifndef UNICODE
 if(IsWindowUnicode((HWND)window))
 {
  wchar_t buffer[MAXICONLEN];

  char2wide(v,NITEM(v),buffer,NITEM(buffer));
  SendMessageW((HWND)window,WM_SETTEXT,0,(LPARAM)buffer);
//  SetWindowTextW((HWND)window,buffer);
  cprintf("write title W");
 }
 else
#endif
*/
 {
  SendMessage((HWND)window,WM_SETTEXT,0,(LPARAM)v);  // cf SetWindowText
 }

 return(NULL);
}






/* complete repaint of window contents */

os_error * refreshwindow(wimp_w handle)
{
 wimp_redrawstr r;
 windowstr      w;

 getw(handle,&w);

 r.box.x0=w.x0-w.bx;
 r.box.x1=w.x1-w.bx;
 r.box.y0=w.y0-w.by;
 r.box.y1=w.y1-w.by;
 r.w=handle;

 return(wimp_force_redraw(&r));
}


void centerwindow3(wimp_openstr * o,int i)
{
 int width;
 int height;
 int left;
 int top;

 width=o->box.x1-o->box.x0;
 height=o->box.y1-o->box.y0;

 left=(cvdu.screenx-width)>>1;
 top=(cvdu.screeny-height)>>1;

 left+=hscrlbar*(i % 4);
 top-=vscrlbar*(i % 5);

 o->box.x0=left;
 o->box.y0=top;
 o->box.x1=o->box.x0+width;
 o->box.y1=o->box.y0+height;
}



void centerwindow2(wimp_wstate * wst,int i)
{
 centerwindow3(&wst->o,i);
}



os_error * centerwindow(wimp_wstate * wst,wimp_w handle,int i)
{
 os_error * err;

 err=wimp_get_wind_state(handle,wst);
 if(!err)
 {
  centerwindow3(&wst->o,i);
  wst->o.behind=(wimp_w)-1;
 }

 return(err);
}



os_error * popup(wimp_w handle,int i)
{
 os_error  * err;
 wimp_wstate wst;

          err=centerwindow(&wst,handle,i);
 if(!err) err=wimp_open_wind(&wst.o);

 return(err);
}



os_error * reopenw(wimp_w handle)
{
 os_error  * err;
 wimp_wstate wst;

 err=wimp_get_wind_state(handle,&wst);
 if(!err) wimp_open_wind(&wst.o);

 return(err);
}


os_error * reopenwlimit(wimp_w handle)
{
 os_error     * err;
 wimp_wstate    wst;
 wimp_redrawstr wr;
 int            maxwidth;
 int            maxheight;
 int            width;
 int            height;

 err=wimp_get_wind_state(handle,&wst);

 wr.w=handle;

 if(!err) err=wimp_get_extent(&wr);
 if(!err)
 {
  maxwidth=wr.box.x1-wr.box.x0;
  maxheight=wr.box.y1-wr.box.y0;
  width=wst.o.box.x1-wst.o.box.x0;
  height=wst.o.box.y1-wst.o.box.y0;


  if(maxwidth && width>maxwidth) wst.o.box.x1=wst.o.box.x0+maxwidth;
  if(maxheight && height>maxheight) wst.o.box.y0=wst.o.box.y1-maxheight;

  wimp_open_wind(&wst.o);
 }

 return(err);
}




os_error * openatscroll(wimp_w handle,int scx,int scy)
{
 os_error *  err;
 wimp_wstate wblock;

 err=wimp_get_wind_state(handle,&wblock);
 if(!err)
 {
  wblock.o.x=scx;
  wblock.o.y=scy;
  err=wimp_open_wind(&wblock.o);
 }

 return(err);
}




os_error * closedown(wimp_w * handlep)
{
 os_error    * err;
 wimp_w        handle;

 handle=*handlep;

 if(handle)
 {
  err=wimp_close_wind(handle);
  if(err)     wimp_delete_wind(handle);
  else    err=wimp_delete_wind(handle);
  *handlep=0;
 }
 else err=NULL;

 return(err);
}




int taskhandle;
// int iconbaricon;

os_error * starttask(void)
{
 taskhandle=GetCurrentProcessId();
 return(NULL);
}




os_error * findwindowtask(wimp_w handle,int icon,int * task)
{
 os_error * err;
 DWORD      process=0;
 DWORD      thread;
 HWND       child;

 if(icon>=0)
 {
           err=XGetDlgItem((HWND)handle,icon,&child);
  if(!err) err=XGetWindowThreadProcessId(child,&process,&thread);
 }
 else
 {
  err=XGetWindowThreadProcessId((HWND)handle,&process,&thread);
//  cprintf("process=%x",process);
 }

 *task=process;

 return(err);
}


// MAX_USERNAME derived from UNLEN in lmcons.h
os_error * getusername(TCHAR * buffer,int buffsize)
{
 os_error * err;
 DWORD      dwSize;

 dwSize=buffsize;

 err=XGetUserName(buffer,&dwSize);

 return(err);
}



int osversion(void)
{
 static osver=0;

 if(osver==0) osver=(XGetVersion()&(~0x7FFF0000)|0x40000000);

 return(osver);
}





void getsumwimpbox(wimp_box * maxbox,wimp_box * box)
{
 maxbox->x0=MIN(maxbox->x0,box->x0);
 maxbox->x1=MAX(maxbox->x1,box->x1);
 maxbox->y0=MIN(maxbox->y0,box->y0);
 maxbox->y1=MAX(maxbox->y1,box->y1);
}



os_error * geticonbox(wimp_w handle,int * group,wimp_box * box)
{
 os_error * err;
 int        c;
 wimp_icon  istate;
 int        first;

 err=NULL;

 first=1;
 while((c=*group++)>=0)
 {
  err=wimp_get_icon_info(handle,c,&istate);
  if(err) break;
  if(first)
  {
   *box=istate.box;
   first=0;
  }
  else
  {
   getsumwimpbox(box,&istate.box);
  }
 }

 return(err);
}



os_error * moveicongroup(wimp_w handle,int * group,int xshift,int yshift)
{
 os_error * err;
// wimp_icon  istate;
 int        c;
 HWND       child;
 RECT       rect;
 RECT       rect2;


// cprintf("move icon group");

 err=NULL;

 if(xshift || yshift)
 {
  while((c=*group++)>=0)
  {
            err=XGetDlgItem((HWND)handle,c,&child);
   if(!err) err=XGetClientRect(child,&rect);
   rect2=rect;
   MapWindowPoints(child,(HWND)handle,(LPPOINT)&rect2,2);

// we have problems with zero height icons, these seem to vanish
// if the height is allowed to change even with the SWP_NOSIZE
// flag their position is not set correctly

  rect2.left+=xos2pix(xshift);
  rect2.top-=yos2pix(yshift);

  err=XSetWindowPos(child,HWND_TOP,rect2.left,rect2.top,0,0,SWP_NOZORDER|SWP_NOSIZE);

  MapWindowPoints(child,(HWND)handle,(LPPOINT)&rect,2);

  if(rect.left!=rect2.left || rect.top!=rect2.top)
  {
   rect2.left-=(rect.left-rect2.left);
   rect2.top-=(rect.top-rect2.top);
   
   err=XSetWindowPos(child,HWND_TOP,rect2.left,rect2.top,0,0,SWP_NOZORDER|SWP_NOSIZE);
  }


#ifdef NEVER   
   err=wimp_get_icon_info(handle,c,&istate);

   if(err) break;

   istate.box.x0+=xshift;
   istate.box.x1+=xshift;
   istate.box.y0+=yshift;
   istate.box.y1+=yshift;
   err=wimp_move_icon(handle,c,&istate);

   if(err) break;

#endif
  }
 }

 return(err);
}


os_error * oscommand(wimp_w parent,TCHAR * verb,TCHAR * file,TCHAR * params,TCHAR * directory,int flags)
{
 ShellExecute((HWND)parent,verb,file,params,directory,SW_SHOW);
 return(NULL);
}



os_error * osreadvar(TCHAR * in,TCHAR * out,int n)
{
 TCHAR temp[1024];

 if(in==out)
 {
  xstrncpy(temp,in,sizeof(temp)/sizeof(TCHAR));
  in=temp;
 }

 ExpandEnvironmentStrings(in,out,n);

 return(NULL);
}


os_error * fx(int a,int x,int y)
{
	wimp_w handle;



 
 if(a==138 && x==0)
	{
  getactive(&handle);
		handle=(wimp_w)GetFocus();
  SendMessage((HWND)handle,WM_CHAR,(WPARAM)y,(LPARAM)0);
	}



#ifdef NEVER	
 if(a==138 && x==0)
	{
  int vkey;

  vkey=VkKeyScan(y);

  keybd_event(vkey & 0xFF,0,0,0);

  keybd_event(vkey & 0xFF,0,KEYEVENTF_KEYUP,0);
 }     
#endif

 return(NULL);
}



