
#include "stdafx.h"

#include <stdlib.h>
#include <stdio.h>
#include <setjmp.h>


#include "os.h"
#include "wimp.h"


#include "etc.h"
#include "err.h"
#include "transform.h"
#include "fsx.h"
#include "bf.h"
#include "flex.h"
#include "alloc.h"
#include "xmath.h"
#include "xprocess.h"
#include "osgraphics.h"
#include "imlib.h"
#include "imrender.h"
#include "osglue.h"
#include "deb.h"
#include "sprx.h"



#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


#include "..\JPEGLIB6b\jpeglib.h"
#include "..\JPEGLIB6b\jmemsrc.h"
#include "..\JPEGLIB6b\iccjpeg.h"

#ifdef __cplusplus
}
#endif /* __cplusplus */



#include "xxjpeg.h"






struct my_error_mgr 
{
 struct jpeg_error_mgr pub;    /* "public" fields */

 jmp_buf setjmp_buffer;        /* for return to caller */
};


typedef struct my_error_mgr * my_error_ptr;


static void my_error_exit(j_common_ptr cinfo)
{
 os_error     * err;
 my_error_ptr   myerr;
 char           string[256];

 myerr=(my_error_ptr)cinfo->err;

 (*cinfo->err->format_message) (cinfo,string);

 err=generror(0,string);

 longjmp(myerr->setjmp_buffer,(int)err);
}




static void internalerror(j_common_ptr cinfo,os_error * err)
{
 my_error_ptr   myerr;

 myerr=(my_error_ptr)cinfo->err;

 longjmp(myerr->setjmp_buffer,(int)err);
}









os_error * jpeg_info(void * data,int len,jpeginfostr * info)
{
 os_error                       * err;
 struct jpeg_decompress_struct    cinfo;
 struct my_error_mgr              jerr;

 err=NULL;


 cinfo.err=jpeg_std_error(&jerr.pub);
 jerr.pub.error_exit=my_error_exit;


 if((err=(os_error*)setjmp(jerr.setjmp_buffer))!=NULL)
 {
  jpeg_destroy_decompress(&cinfo);
  return(err);
 }


 jpeg_create_decompress(&cinfo);

 jpeg_memory_src(&cinfo,data,len);

 jpeg_read_header(&cinfo, TRUE);

 jpeg_calc_output_dimensions(&cinfo);



 info->xpix=(int)cinfo.image_width;
 info->ypix=(int)cinfo.image_height;
 info->components=cinfo.output_components;
 
 if(cinfo.X_density==cinfo.Y_density && cinfo.X_density==0)
 {
  cinfo.X_density=90;
  cinfo.Y_density=90;
  cinfo.density_unit=1;
 }


 if(cinfo.density_unit==0)
 {
  info->xdpi=90;
  info->ydpi=(90*cinfo.X_density)/cinfo.Y_density;
 }
 else
 if(cinfo.density_unit==1)  /* dpi */
 {
  info->xdpi=cinfo.X_density;
  info->ydpi=cinfo.Y_density;
 }
 else
 if(cinfo.density_unit==2) /* dpcm */
 {
  info->xdpi=(100*cinfo.X_density)/254;
  info->ydpi=(100*cinfo.Y_density)/254;
 }

 if(info->xdpi<10) info->xdpi=90;
 if(info->ydpi<10) info->ydpi=90;


 jpeg_destroy_decompress(&cinfo);

 return(err);
}




  /* This routine can initialize for output based on the data passed in cinfo.
   * Useful fields include:
   *    image_width, image_height       Pretty obvious, I hope.
   *    data_precision                  bits per pixel value; typically 8.
   *    out_color_space                 output colorspace previously requested
   *    color_out_comps                 number of color components in same
   *    final_out_comps                 number of components actually output
   * final_out_comps is 1 if quantize_colors is true, else it is equal to
   * color_out_comps.
   *
   * If you have requested color quantization, the colormap is NOT yet set.
   * You may wish to defer output initialization until put_color_map is called.
   */


static void output_init(j_decompress_ptr cinfo,framestr ** frames,framebasestr ** framebase,
                        unsigned char ** iccdata,unsigned int icclen)
{
 os_error * err;
 framestr * framep;
 int        bpp;


 err=imaddframe(framebase,frames);
 if(!err)
 {
  framep=*frames;

  strcpy(framep->name,"JPEG");
  framep->offset=0;
  framep->planes=1;

  framep->im[IM].topdown=0;

  if(cinfo->output_components==4) bpp=32;
  else
  if(cinfo->output_components==3) bpp=24;
  else                            bpp=8;

  err=imnew((int)cinfo->image_width,(int)cinfo->image_height,bpp,&framep->im[0]);

  if(cinfo->X_density==cinfo->Y_density && cinfo->X_density==0)
  {
   cinfo->X_density=90;
   cinfo->Y_density=90;
   cinfo->density_unit=1;
  }


  if(cinfo->density_unit==0)
  {
   framep->im[IM].xdpi=90;
   framep->im[IM].ydpi=(90*cinfo->X_density)/cinfo->Y_density;
  }
  else
  if(cinfo->density_unit==1)  /* dpi */
  {
   framep->im[IM].xdpi=cinfo->X_density;
   framep->im[IM].ydpi=cinfo->Y_density;
  }
  else
  if(cinfo->density_unit==2) /* dpcm */
  {
   framep->im[IM].xdpi=(100*cinfo->X_density)/254;
   framep->im[IM].ydpi=(100*cinfo->Y_density)/254;
  }

  if(framep->im[IM].xdpi<10) framep->im[IM].xdpi=90;
  if(framep->im[IM].ydpi<10) framep->im[IM].ydpi=90;

		if(*iccdata)
		{
			framep->im[IM].iccdata=*iccdata;
			framep->im[IM].icclen=icclen;
			*iccdata=NULL;
		}

  if(!err)
  {
   if(cinfo->output_components==1)
   {
    gengreypal(3,&framep->im[IM].ipal.ncolours,framep->im[IM].ipal.word);
    for(int i=0;i<framep->im[IM].ipal.ncolours;i++)
    {
     framep->im[IM].ipal.word[i]=QUADFROMPAL(framep->im[IM].ipal.word[i]);
    }
    framep->im[IM].ipal.palclass=CL_GREY;
   }
   else
   {
    framep->im[IM].ipal.ncolours=0;
    framep->im[IM].ipal.palclass=(cinfo->output_components==4)?CL_CMYK:CL_RGB;
   }
  }
 }
}






/*
 * Reading a JPEG file that may contain an ICC profile requires two steps:
 *
 * 1. After jpeg_create_decompress() but before jpeg_read_header(),
 *    call setup_read_icc_profile().  This routine tells the IJG library
 *    to save in memory any APP2 markers it may find in the file.
 *
 * 2. After jpeg_read_header(), call read_icc_profile() to find out
 *    whether there was a profile and obtain it if so.
 */


/*
 * Prepare for reading an ICC profile
 */

//extern void setup_read_icc_profile JPP((j_decompress_ptr cinfo));


/*
 * See if there was an ICC profile in the JPEG file being read;
 * if so, reassemble and return the profile data.
 *
 * TRUE is returned if an ICC profile was found, FALSE if not.
 * If TRUE is returned, *icc_data_ptr is set to point to the
 * returned data, and *icc_data_len is set to its length.
 *
 * IMPORTANT: the data at **icc_data_ptr has been allocated with malloc()
 * and must be freed by the caller with free() when the caller no longer
 * needs it.  (Alternatively, we could write this routine to use the
 * IJG library's memory allocator, so that the data would be freed implicitly
 * at jpeg_finish_decompress() time.  But it seems likely that many apps
 * will prefer to have the data stick around after decompression finishes.)
 */

//extern boolean read_icc_profile JPP((j_decompress_ptr cinfo,
//				     JOCTET **icc_data_ptr,
//				     unsigned int *icc_data_len));




os_error * jpeg_getframe(void * data,int len,framebasestr ** framebase)
{
 os_error                     * err;
 framestr                     * frames;
 struct jpeg_decompress_struct  cinfo;
 struct my_error_mgr            jerr;
 int                          * idata;
	unsigned int                   icclen;
	unsigned char                * iccdata;



 err=imnewframebase(framebase);
 if(!err)
 {
  cinfo.err=jpeg_std_error(&jerr.pub);
  jerr.pub.error_exit=my_error_exit;


  if((err=(os_error*)setjmp(jerr.setjmp_buffer))!=NULL)
  {
   jpeg_destroy_decompress(&cinfo);
   imscrapframebase(framebase);
   return(err);
  }



  jpeg_create_decompress(&cinfo);

  setup_read_icc_profile(&cinfo);

  jpeg_memory_src(&cinfo,data,len);

  jpeg_read_header(&cinfo,TRUE);


  if(!read_icc_profile(&cinfo,&iccdata,&icclen))
  {
   iccdata=NULL;
  }


  jpeg_start_decompress(&cinfo);

  output_init(&cinfo,&frames,framebase,&iccdata,icclen);


  while(cinfo.output_scanline<cinfo.output_height)
  {
   err=imfind1w(&frames->im[0],(cinfo.output_height-1)-cinfo.output_scanline,&idata);

   jpeg_read_scanlines(&cinfo,(unsigned char **)&idata,1);

 		if(cinfo.jpeg_color_space==JCS_RGB)
   {
    char * r;
    char * b;
    char * blt;

    r=b=(char*)idata;
    r+=2;
    blt=b+cinfo.image_width*3;
    while(b<blt)
    {
     SWOP((*r),(*b));
     r+=3;
     b+=3;
    }
   }
			else
   if(cinfo.jpeg_color_space==JCS_CMYK)
   {
    int * p;
    int * lt;

    p=idata;
    lt=p+cinfo.image_width;
    while(p<lt)
    {
     *p=(*p)^0xFFFFFFFF;
     p++;
    }
   }


   if(err) internalerror((j_common_ptr)&cinfo,err);
  }


  jpeg_finish_decompress(&cinfo);

  jpeg_destroy_decompress(&cinfo);

  if(iccdata)
  {
   free(iccdata);
  }

 }

 return(err);
}




os_error * jpeg_render(void * data,int len,transformstr * tr,int bits,processstr * pr)
{
 os_error                     * err;
 framestr                     * frames;
 framebasestr                 * framebase;
 coordstr                       cx[4];


	cprintf("jpeg_render len %d",len);

 err=jpeg_getframe(data,len,&framebase);
 if(!err)
 {
  frames=framebase->frame;
  
  cx[0].x=0;
  cx[0].y=0;
  cx[1].x=scale(frames->im[IM].xpix,180*256,frames->im[IM].xdpi);
  cx[1].y=0;
  cx[2].x=cx[1].x;
  cx[2].y=scale(frames->im[IM].ypix,180*256,frames->im[IM].ydpi);
  cx[3].x=0;
  cx[3].y=cx[2].y;

  tr_transformset(cx,4,tr);

  err=impaintbox(frames,cx,pr);

  imscrapframebase(&framebase);
 }

 return(err);
}
